import maploader
import pygame
import math

DRESSER_DAY1 = 1
DOOR_DAY1 = 2
DAY1_MELODYGIFT = 3
DAY1_MOONFIREGIFT = 4
DAY1_PICNIC = 5
DAY1_OUTSIDEROSEWINDDOOR = 6
DAY1_OUTSKIRTSCUTSCENE1 = 7
PATH_OUTSKIRTS_TO_MAIN_STREET = 8
PATH_MAIN_STREET_TO_OUTSKIRTS = 9
PATH_MAIN_STREET_TO_TOWER = 10
PATH_TOWER_TO_MAIN_STREET = 11
SIGNPOST_WEAPONSHOP = 12
SIGNPOST_BAKERY = 13
SIGNPOST_ACCESSORYSHOP = 14
BUSYBEE = 15
SPARKY = 16
WEAPON_SHOP_OUTSIDE_DOOR = 17
WEAPON_SHOP_INSIDE_DOOR = 18
EMBERSONG = 19
IRONHOOF = 20
STARSEEKER = 21
ACCESSORY_SHOP_OUTSIDE_DOOR = 22
ACCESSORY_SHOP_INSIDE_DOOR = 23
VANILLY = 24
BAKERY_OUTSIDE_DOOR = 25
BAKERY_INSIDE_DOOR = 26
BUTTERBELL = 27
DAY1_TOWER_LOCKED_CUTSCENE = 28
TOWER_OUTSIDE_DOOR = 29
SILVERFLAKEOUTSIDEDOOR = 30
DAY1_SILVERFLAKEDOORCUTSCENE = 31
DAY1_TOWERINTRO = 32
TOWER_LOWER_EXIT = 33
TOWER_HIGHER_EXIT = 34
TOWER_BOSS_LOWER_EXIT = 35
TOWER_BOSS_HIGHER_EXIT = 36
DAY1_BOSSINTRO = 37
BOSS_MACHINE = 38
ORB = 39
WARP = 40
OUTSIDEMELODYDOOR = 41
OUTSIDEROSEWINDDOOR = 42
DAY2_MELODY = 43
DAY2_MOONFIRECUTSCENE = 44
DAY2_BUSYBEECUTSCENE = 45
DAY2_LEVELINTRO = 46
DAY2_BOSSINTRO = 47
MELODYHOUSEINSIDEDOOR = 48
DAY3_MELODYHOUSECUTSCENE = 49
DAY3_SILVERFLAKEHOUSECUTSCENE = 50
DAY3_FLAVOUR = 51
DAY3_LEVELINTRO = 52
DAY3_BOSSINTRO = 53
DAY4_MELODY = 54
DAYLOGO = 55
DAY4_MOONFIRE = 56
DAY4_FOGCUTSCENE = 57
SILVERFLAKE = 58
SILVERFLAKEINSIDEDOOR = 59
DAY4_LEVELINTRO = 60
DAY4_BOSSINTRO = 61
DAY5_BOSSINTRO = 62
DAY6_BOSSINTRO = 63
DAY7_BOSSINTRO = 64
DAY8_BOSSINTRO = 65
DAY9_BOSSINTRO = 66
DAY5_LEVELINTRO = 67
DAY6_LEVELINTRO = 68
DAY7_LEVELINTRO = 69
DAY8_LEVELINTRO = 70
DAY9_LEVELINTRO = 71
DAY6_WAKEUP = 72
DAY9_WAKEUP = 73
ORBDEAD = 74
ORBBOSS = 75
WINSCRIPT = 76
DEADSILVER = 77
CHEST = 78

def update(self, obj, game):
    id = self.oid[obj]
    if id == DRESSER_DAY1:
        uDresserDay1(self, obj, game)
    if id == DOOR_DAY1:
        uDoorDay1(self, obj, game)
    if id == DAY1_MELODYGIFT:
        uDay1MelodyGift(self, obj, game)
    if id == DAY1_MOONFIREGIFT:
        uDay1MoonfireGift(self, obj, game)
    if id == DAY1_PICNIC:
        uDay1Picnic(self, obj, game)
    if id == DAY1_OUTSIDEROSEWINDDOOR:
        uDay1OutsideRosewindDoor(self, obj, game)
    if id == DAY1_OUTSKIRTSCUTSCENE1:
        uDay1OutskirtsCutscene(self, obj, game)
    if id == PATH_OUTSKIRTS_TO_MAIN_STREET:
        uPathOutskirtsMainstreet(self, obj, game)
    if id == PATH_MAIN_STREET_TO_OUTSKIRTS:
        uPathMainstreetOutskirts(self, obj, game)
    if id == PATH_MAIN_STREET_TO_TOWER:
        uPathMainstreetTower(self, obj, game)
    if id == PATH_TOWER_TO_MAIN_STREET:
        uPathTowerMainstreet(self, obj, game)
    if id == SIGNPOST_WEAPONSHOP:
        uSignpostWeaponShop(self, obj, game)
    if id == SIGNPOST_BAKERY:
        uSignpostBakery(self, obj, game)
    if id == SIGNPOST_ACCESSORYSHOP:
        uSignpostAccessoryShop(self, obj, game)
    if id == BUSYBEE:
        uBusybee(self, obj, game)
    if id == SPARKY:
        uSparky(self, obj, game)
    if id == WEAPON_SHOP_OUTSIDE_DOOR:
        uWeaponShopOutsideDoor(self, obj, game)
    if id == WEAPON_SHOP_INSIDE_DOOR:
        uWeaponShopInsideDoor(self, obj, game)
    if id == EMBERSONG:
        uEmbersong(self, obj, game)
    if id == IRONHOOF:
        uIronhoof(self, obj, game)
    if id == STARSEEKER:
        uStarseeker(self, obj, game)
    if id == ACCESSORY_SHOP_OUTSIDE_DOOR:
        uAccessoryShopOutsideDoor(self, obj, game)
    if id == ACCESSORY_SHOP_INSIDE_DOOR:
        uAccessoryShopInsideDoor(self, obj, game)
    if id == VANILLY:
        uVanilly(self, obj, game)
    if id == BAKERY_OUTSIDE_DOOR:
        uBakeryOutsideDoor(self, obj, game)
    if id == BAKERY_INSIDE_DOOR:
        uBakeryInsideDoor(self, obj, game)
    if id == BUTTERBELL:
        uButterbell(self, obj, game)
    if id == DAY1_TOWER_LOCKED_CUTSCENE:
        uDay1TowerLockedCutscene(self, obj, game)
    if id == TOWER_OUTSIDE_DOOR:
        uTowerOutsideDoor(self, obj, game)
    if id == SILVERFLAKEOUTSIDEDOOR:
        uSilverflakeOutsideDoor(self, obj, game)
    if id == DAY1_SILVERFLAKEDOORCUTSCENE:
        uDay1SilverflakeDoorCutscene(self, obj, game)
    if id == DAY1_TOWERINTRO:
        uDay1TowerIntro(self, obj, game)
    if id == TOWER_LOWER_EXIT:
        uTowerLowerExit(self, obj, game)
    if id == TOWER_HIGHER_EXIT:
        uTowerHigherExit(self, obj, game)
    if id == TOWER_BOSS_LOWER_EXIT:
        uTowerBossLowerExit(self, obj, game)
    if id == TOWER_BOSS_HIGHER_EXIT:
        uTowerBossHigherExit(self, obj, game)
    if id == DAY1_BOSSINTRO:
        uDay1BossIntro(self, obj, game)
    if id == BOSS_MACHINE:
        uBossMachine(self, obj, game)
    if id == ORB:
        uOrb(self, obj, game)
    if id == WARP:
        uWarp(self, obj, game)
    if id == OUTSIDEMELODYDOOR:
        uOutsideMelodyDoor(self, obj, game)
    if id == OUTSIDEROSEWINDDOOR:
        uOutsideRosewindDoor(self, obj, game)
    if id == DAY2_MELODY:
        uDay2Melody(self, obj, game)
    if id == DAY2_MOONFIRECUTSCENE:
        uDay2MoonfireCutscene(self, obj, game)
    if id == DAY2_BUSYBEECUTSCENE:
        uDay2BusybeeCutscene(self, obj, game)
    if id == DAY2_LEVELINTRO:
        uDay2LevelIntro(self, obj, game)
    if id == DAY2_BOSSINTRO:
        uDay2BossIntro(self, obj, game)
    if id == MELODYHOUSEINSIDEDOOR:
        uMelodyHouseInsideDoor(self, obj, game)
    if id == DAY3_MELODYHOUSECUTSCENE:
        uDay3MelodyHouseCutscene(self, obj, game)
    if id == DAY3_SILVERFLAKEHOUSECUTSCENE:
        uDay3SilverflakeHouseCutscene(self, obj, game)
    if id == DAY3_FLAVOUR:
        uDay3Flavour(self, obj, game)
    if id == DAY3_LEVELINTRO:
        uDay3LevelIntro(self, obj, game)
    if id == DAY3_BOSSINTRO:
        uDay3BossIntro(self, obj, game)
    if id == DAY4_MELODY:
        uDay4Melody(self, obj, game)
    if id == DAYLOGO:
        uDayLogo(self, obj, game)
    if id == DAY4_MOONFIRE:
        uDay4Moonfire(self, obj, game)
    if id == DAY4_FOGCUTSCENE:
        uDay4FogCutscene(self, obj, game)
    if id == SILVERFLAKE:
        uSilverflake(self, obj, game)
    if id == SILVERFLAKEINSIDEDOOR:
        uSilverflakeInsideDoor(self, obj, game)
    if id == DAY4_LEVELINTRO:
        uDay4LevelIntro(self, obj, game)
    if id == DAY4_BOSSINTRO:
        uDay4BossIntro(self, obj, game)
    if id == DAY5_LEVELINTRO:
        uDay5LevelIntro(self, obj, game)
    if id == DAY5_BOSSINTRO:
        uDay5BossIntro(self, obj, game)
    if id == DAY6_LEVELINTRO:
        uDay6LevelIntro(self, obj, game)
    if id == DAY6_BOSSINTRO:
        uDay6BossIntro(self, obj, game)
    if id == DAY7_LEVELINTRO:
        uDay7LevelIntro(self, obj, game)
    if id == DAY7_BOSSINTRO:
        uDay7BossIntro(self, obj, game)
    if id == DAY8_LEVELINTRO:
        uDay8LevelIntro(self, obj, game)
    if id == DAY8_BOSSINTRO:
        uDay8BossIntro(self, obj, game)
    if id == DAY9_LEVELINTRO:
        uDay9LevelIntro(self, obj, game)
    if id == DAY9_BOSSINTRO:
        uDay9BossIntro(self, obj, game)
    if id == DAY6_WAKEUP:
        uDay6WakeUp(self, obj, game)
    if id == DAY9_WAKEUP:
        uDay9WakeUp(self, obj, game)
    if id == ORBDEAD:
        uOrbdead(self, obj, game)
    if id == ORBBOSS:
        uOrbBoss(self, obj, game)
    if id == WINSCRIPT:
        uWin(self, obj, game)
    if id == DEADSILVER:
        uDeadSilver(self, obj, game)
    if id == CHEST:
        uChest(self, obj, game)
    return

def draw(self, obj):
    id = self.oid[obj]
    if id == DAY1_MELODYGIFT:
        dDay1MelodyGift(self, obj)
    if id == DAY1_MOONFIREGIFT:
        dDay1MoonfireGift(self, obj)
    if id == DAY1_PICNIC:
        dDay1Picnic(self, obj)
    if id == DAY1_OUTSKIRTSCUTSCENE1:
        dDay1OutskirtsCutscene(self, obj)
    if id == BUSYBEE:
        dBusybee(self, obj)
    if id == SPARKY:
        dSparky(self, obj)
    if id == EMBERSONG:
        dEmbersong(self, obj)
    if id == IRONHOOF:
        dIronhoof(self, obj)
    if id == STARSEEKER:
        dStarseeker(self, obj)
    if id == VANILLY:
        dVanilly(self, obj)
    if id == BUTTERBELL:
        dButterbell(self, obj)
    if id == DAY1_BOSSINTRO:
        dDay1BossIntro(self, obj)
    if id == BOSS_MACHINE:
        dBossMachine(self, obj)
    if id == ORB:
        dOrb(self, obj)
    if id == WARP:
        dWarp(self, obj)
    if id == DAY2_MELODY:
        dDay2Melody(self, obj)
    if id == DAY3_SILVERFLAKEHOUSECUTSCENE:
        dDay3SilverflakeHouseCutscene(self, obj)
    if id == DAY4_MELODY:
        dDay4Melody(self, obj)
    if id == DAYLOGO:
        dDayLogo(self, obj)
    if id == DAY4_MOONFIRE:
        dDay4Moonfire(self, obj)
    if id == SILVERFLAKE:
        dSilverflake(self, obj)
    if id == ORBDEAD:
        dOrbdead(self, obj)
    if id == ORBBOSS:
        dOrbBoss(self, obj)
    if id == DEADSILVER:
        dDeadSilver(self, obj)
    if id == CHEST:
        dChest(self, obj)
    return

def touching(self, obj):
    return (self.p1x + 23 > self.ox[obj] and self.p1x < self.ox[obj] + self.ow[obj] and self.p1y + 23 > self.oy[obj] and self.p1y < self.oy[obj] + self.oh[obj])

def uDresserDay1(self, obj, game):
    if touching(self, obj):
      if game.mykeys.keyPrimaryIsReleased == True:
        self.createDialogBox(self.portraits[0], "Oh, this RIBBON looks perfect! I'll put it on right away. (Press the shift key to bring up your inventory.)")
        game.mykeys.keyPrimaryIsReleased = False
        self.os[obj] = 0
        self.progression += 1
    return

def uDoorDay1(self, obj, game):
    if touching(self, obj):
        if self.progression < 4:
            self.createDialogBox(self.portraits[0], "I can't leave yet! I still have some things to pick up!")
            self.p1y = self.p1y - 3
            self.p1dir = 1
        else:
            self.nextmap = maploader.OUTSKIRTS
            self.os[obj] = 0
    return

def uDay1MelodyGift(self, obj, game):
    if touching(self, obj):
      if game.mykeys.keyPrimaryIsReleased == True:
        self.createDialogBox(self.portraits[0], "Here's Melody's gift! She will love it, I'm sure! (Picked up the saddle!)")
        game.mykeys.keyPrimaryIsReleased = False
        self.os[obj] = 0
        self.progression += 1
    return

def dDay1MelodyGift(self, obj):
    self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y + 32), (0, 0, 32, 32))
    return

def uDay1MoonfireGift(self, obj, game):
    if touching(self, obj):
      if game.mykeys.keyPrimaryIsReleased == True:
        self.createDialogBox(self.portraits[0], "Here's Moonfire's gift! Oh, I wish I had the time to wrap it up, but I don't think he'll mind. (Picked up the cape!)")
        game.mykeys.keyPrimaryIsReleased = False
        self.os[obj] = 0
        self.progression += 1
    return

def dDay1MoonfireGift(self, obj):
    self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x + 32, self.oy[obj] - self.camera.y), (32, 0, 32, 32))
    return

def uDay1Picnic(self, obj, game):
    if touching(self, obj):
      if game.mykeys.keyPrimaryIsReleased == True:
        self.createDialogBox(self.portraits[0], "Mmm, I can't wait to taste that pie I bought from Butterbell. Her cooking is the best. (Picked up the APPLE PIE!)")
        game.mykeys.keyPrimaryIsReleased = False
        self.os[obj] = 0
        self.progression += 1
    return

def dDay1Picnic(self, obj):
    self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (64, 0, 32, 32))
    return

def uDay1OutsideRosewindDoor(self, obj, game):
    if touching(self, obj):
        self.nextmap = maploader.ROSEWINDHOUSE
        self.os[obj] = 0
    return

def uDay1OutskirtsCutscene(self, obj, game):
    if(self.os[obj] == 1):
        self.freeze = True
        self.createDialogBox(self.portraits[1], "Melody: Rosewind! It's terrible!")
    if(self.os[obj] < 180):
        self.os[obj] += 1
    if(self.os[obj] == 180 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: What? What's wrong?")
        self.os[obj] = 1000
    if(self.os[obj] == 1000 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Look at the sky... it's getting cloudier by the minute. We'll have to cancel the picnic.")
        self.os[obj] = 1001
    if(self.os[obj] == 1001 and self.isShowingDialogBox == False):
        self.os[obj] = 1002
        self.createDialogBox(self.portraits[0], "Rosewind: But it was supposed to be sunny today! I've been waiting all week for this!")
    if(self.os[obj] == 1002 and self.isShowingDialogBox == False):
        self.os[obj] = 1003
        self.createDialogBox(self.portraits[1], "Melody: What are we going to do?")
    if(self.os[obj] == 1003 and self.isShowingDialogBox == False):
        self.os[obj] = 1004
        self.createDialogBox(self.portraits[0], "Rosewind: Hmm... I think I have an idea. We should go to the Weather Tower! If it's not keeping the clouds out of the sky like it's supposed to, this means something must be wrong.")
    if(self.os[obj] == 1004 and self.isShowingDialogBox == False):
        self.os[obj] = 1005
        self.createDialogBox(self.portraits[2], "Moonfire: Good idea. We're coming along with you.")
    if(self.os[obj] == 1005 and self.isShowingDialogBox == False):
        self.os[obj] = 1006
        self.createDialogBox(self.portraits[0], "(Moonfire the unicorn and Melody the pegasus have joined your party!)")
    if(self.os[obj] == 1006 and self.isShowingDialogBox == False):
        self.os[obj] = 1007
        self.createDialogBox(self.portraits[0], "Rosewind: Let's see... the Weather Tower is at the center of the village. Let's go!")
    if(self.os[obj] == 1007 and self.isShowingDialogBox == False):
        self.os[obj] = 2000
    if(self.os[obj] >= 2000 and self.os[obj] < 2050):
        self.os[obj] += 1
    if(self.os[obj] >= 2050):
        self.os[obj] = 0
        self.player.hasMelody = True
        self.player.hasMoonfire = True
        self.p2dir = 3
        self.p3dir = 3
        self.p3x = 49 * 32
        self.p3y = 16 * 32
        self.p2x = 49 * 32
        self.p2y = 16 * 32
        self.freeze = False;
        self.progression = 5
    return

def dDay1OutskirtsCutscene(self, obj):
    if(self.os[obj] < 2000):
        walking = True
        position = -self.os[obj] + 56 * 32
        if position < 51 * 32:
            position = 51 * 32
            walking = False
        if walking == True:
            frame = (self.os[obj] / 12)% 6
            self.screen.blit(self.player.moonfire.walkLeftAnimation[frame], (position - self.camera.x - 32 - 4, 17 * 32 - self.camera.y - 32 - 4))
        else:
            self.screen.blit(self.player.moonfire.idleLeft, (position - self.camera.x - 32 - 4, 17 * 32 - self.camera.y - 32 - 4))

        walking = True
        position = -self.os[obj]*2 + 60 * 32
        if position < 50 * 32:
            position = 50 * 32
            walking = False
        if walking == True:
            frame = (self.os[obj] / 6)% 6
            self.screen.blit(self.player.melody.walkLeftAnimation[frame], (position - self.camera.x - 32 - 4, 18 * 32 - self.camera.y - 32 - 4))
        else:
            self.screen.blit(self.player.melody.idleLeft, (position - self.camera.x - 32 - 4, 18 * 32 - self.camera.y - 32 - 4))
    else:
        if(self.os[obj] < 2020):
            walking = True
            position = -(self.os[obj] - 2000)*2 + 51 * 32
            if position < 49 * 32:
                position = 49 * 32
                walking = False
            if walking == True:
                frame = (self.os[obj] / 12)% 6
                self.screen.blit(self.player.moonfire.walkLeftAnimation[frame], (position - self.camera.x - 32 - 4, 17 * 32 - self.camera.y - 32 - 4))
            else:
                self.screen.blit(self.player.moonfire.idleLeft, (position - self.camera.x - 32 - 4, 17 * 32 - self.camera.y - 32 - 4))

            walking = True
            position = -(self.os[obj] - 2000)*4 + 50 * 32
            if position < 49 * 32:
                position = 49 * 32
                walking = False
            if walking == True:
                frame = (self.os[obj] / 6)% 6
                self.screen.blit(self.player.melody.walkLeftAnimation[frame], (position - self.camera.x - 32 - 4, 18 * 32 - self.camera.y - 32 - 4))
            else:
                self.screen.blit(self.player.melody.idleLeft, (position - self.camera.x - 32 - 4, 18 * 32 - self.camera.y - 32 - 4))
        else:
            walking = True
            position = -(self.os[obj] - 2020)*2 + 17 * 32
            if position < 16 * 32:
                position = 16 * 32
                walking = False
            if walking == True:
                frame = (self.os[obj] / 12)% 6
                self.screen.blit(self.player.moonfire.walkUpAnimation[frame], (49 * 32 - self.camera.x - 32 - 4, position - self.camera.y - 32 - 4))
            else:
                self.screen.blit(self.player.moonfire.idleDown, (49 * 32 - self.camera.x - 32 - 4, position - self.camera.y - 32 - 4))

            walking = True
            position = -(self.os[obj] - 2020)*4 + 18 * 32
            if position < 16 * 32:
                position = 16 * 32
                walking = False
            if walking == True:
                frame = (self.os[obj] / 6)% 6
                self.screen.blit(self.player.melody.walkUpAnimation[frame], (49 * 32 - self.camera.x - 32 - 4, position - self.camera.y - 32 - 4))
            else:
                self.screen.blit(self.player.melody.idleDown, (49 * 32 - self.camera.x - 32 - 4, position * 32 - self.camera.y - 32 - 4))
    return

def uPathOutskirtsMainstreet(self, obj, game):
    if(self.day == 1 or self.day == 2 or self.day == 4 or self.day == 5 or self.day == 6 or self.day == 7 or self.day == 8 or self.day == 9):
        if touching(self, obj):
            self.nextmap = maploader.MAINSTREET
            self.os[obj] = 0

    if(self.day == 3 ):
        if(self.progression == 201):
            if touching(self, obj):
                self.createDialogBox(self.portraits[0], "Melody lives really close, I shouldn't wander.")
                self.p1x += 3
        else:
            if touching(self, obj):
                self.nextmap = maploader.MAINSTREET
                self.os[obj] = 0
            
    return

def uPathMainstreetOutskirts(self, obj, game):
    if(self.day == 1):
        if touching(self, obj):
            if self.progression == 5:
                self.createDialogBox(self.portraits[2], "Moonfire: That's not the way to the tower!")
                self.p1x -= 3
            else:
                self.nextmap = maploader.OUTSKIRTS
                self.os[obj] = 0

    if(self.day == 2 and self.progression == 102):
        if touching(self, obj):
            self.p1x -= 3
            self.createDialogBox(self.portraits[1], "Melody: We have to go to the weapons shop to get Moonfire!")

    if(self.day == 2 and self.progression != 102):
        if touching(self, obj):
            self.nextmap = maploader.OUTSKIRTS
            self.os[obj] = 0

    if(self.day > 2):
        if touching(self, obj):
            self.nextmap = maploader.OUTSKIRTS
            self.os[obj] = 0 
    
    return

def uPathMainstreetTower(self, obj, game):
    if(self.day == 1 or self.day == 5 or self.day == 6 or self.day == 7 or self.day == 8 or self.day == 9):
        if touching(self, obj):
            self.nextmap = maploader.TOWEROUTSIDE
            self.os[obj] = 0

    if(self.day == 2 and self.progression == 102):
        if touching(self, obj):
            self.p1y += 3
            self.createDialogBox(self.portraits[1], "Melody: We have to go to the weapons shop to get Moonfire!")

    if(self.day == 2 and self.progression != 102):
        if touching(self, obj):
            self.nextmap = maploader.TOWEROUTSIDE
            self.os[obj] = 0

    if(self.day == 3 or self.day == 5 or self.day == 6 or self.day == 7 or self.day == 8 or self.day == 9):
        if touching(self, obj):
            self.nextmap = maploader.TOWEROUTSIDE
            self.os[obj] = 0

    if(self.day == 4 and self.progression < 310):
        if touching(self, obj):
            self.p1y += 3
            self.createDialogBox(self.portraits[0], "Rosewind: There's no need to check the weather tower today.")

    if(self.day == 4 and self.progression >= 310):
        if touching(self, obj):
            self.nextmap = maploader.TOWEROUTSIDE
            self.os[obj] = 0

    return

def uPathTowerMainstreet(self, obj, game):
    if touching(self, obj):
        if self.progression < 7:
            self.createDialogBox(self.portraits[0], "We need to check out the tower!")
            self.p1y -= 4
            return
        self.nextmap = maploader.MAINSTREET
        self.os[obj] = 0
    return

def uSignpostWeaponShop(self, obj, game):
    if touching(self, obj) and game.mykeys.keyPrimaryIsReleased == True:
        self.createDialogBox(self.portraits[0], "Embersong, Ironhoof and Starseeker's : all the weapons you need!")
        game.mykeys.keyPrimaryIsReleased = False
    return

def uSignpostBakery(self, obj, game):
    if touching(self, obj) and game.mykeys.keyPrimaryIsReleased == True:
        self.createDialogBox(self.portraits[0], "Butterbell's delicious emporium!")
        game.mykeys.keyPrimaryIsReleased = False
    return

def uSignpostAccessoryShop(self, obj, game):
    if touching(self, obj) and game.mykeys.keyPrimaryIsReleased == True:
        self.createDialogBox(self.portraits[0], "Vanilly's accessories : stylish and useful!")
        game.mykeys.keyPrimaryIsReleased = False 
    return

def uBusybee(self, obj, game):
    if(self.day == 1):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: Don't bother me right now, Rosewind. I have to put all my clothes away before it rains.")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 2):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: I'm afraid I can't talk right now. I couldn't get anything done yesterday because of that blasted storm!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 3):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: Out of my way, out of my way! It was so hot yesterday that I could barely move!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 4 and self.progression < 310):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: Please don't get in my way! Because I was running around so much yesterday, I tired myself out and woke up REALLY late today!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 4 and self.progression >= 310):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: Oof! Look where you're going, filly!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 5):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: *pant pant* Move, move, move! This wind knocked stuff all over my lawn, I have to pick them all off!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 6):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: Not now, not now, must shovel all this snow!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 7):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: Run for your life, you fool!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 8):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: I can't waste time chatting with you! I have to get everything to safety before the lava gets here!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 9):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[8], "Busybee: ...")
                game.mykeys.keyPrimaryIsReleased = False
                
    return

def dBusybee(self, obj):
    self.screen.blit(self.npcPoniesImage, (self.ox[obj] - self.camera.x - 32, self.oy[obj] - self.camera.y - 32), (4*96, 0, 96, 80))
    return

def uSparky(self, obj, game):
    if(self.day == 1):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: Hey! Isn't this dark sky cool? It looks like a great storm is coming up! I love running around and jumping in puddles in the rain! Don't you, Rosie?")
                game.mykeys.keyPrimaryIsReleased = False
                self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
                self.os[obj] = 3
                self.createDialogBox(self.portraits[0], "Rosewind: Not really, to be honest.")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
                self.os[obj] = 1
                self.createDialogBox(self.portraits[5], "Sparky: Oh... oh well!")

    if(self.day == 2):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: Don't you just LOVE the sun, Rosie? It's so refreshing!")
                game.mykeys.keyPrimaryIsReleased = False
                self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
                self.os[obj] = 1
                self.createDialogBox(self.portraits[0], "Rosewind: It IS nice, yes. A little hot, though.")

    if(self.day == 3):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: Whee! Splish! Splash! Come on, Rosie, play with me!")
                game.mykeys.keyPrimaryIsReleased = False
                self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
                self.os[obj] = 1
                self.createDialogBox(self.portraits[0], "Rosewind: Maybe later.")

    if(self.day == 4 and self.progression < 310):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: Rosie!")
                game.mykeys.keyPrimaryIsReleased = False
                self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
                self.os[obj] = 3
                self.createDialogBox(self.portraits[0], "Rosewind: Yes?")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
                self.os[obj] = 1
                self.createDialogBox(self.portraits[5], "Sparky: Nothing! I just like saying your name. Rosie! Rooooosie! Hee hee hee")

    if(self.day == 4 and self.progression >= 310):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: I rad idto a wall ad hurd by dose! ")
                game.mykeys.keyPrimaryIsReleased = False
                self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
                self.os[obj] = 3
                self.createDialogBox(self.portraits[0], "Oh no! Are you okay?")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
                self.os[obj] = 1
                self.createDialogBox(self.portraits[5], "Sparky: Hee hee, of courze! Dow I zbeak all fuddy!")

    if(self.day == 5):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: Whee, I love getting pushed along by the wind!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 6):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: I'm making a Snowny!")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 7):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: Woah, an earthquake! Isn't this exciting??")
                game.mykeys.keyPrimaryIsReleased = False

    if(self.day == 8):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: Ooh, a volcano! Do you think we'll get to see lava?")
                game.mykeys.keyPrimaryIsReleased = False
                self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
                self.os[obj] = 1
                self.createDialogBox(self.portraits[0], "Rosewind: I hope not...")

    if(self.day == 9):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[5], "Sparky: ...this is weird.")
                game.mykeys.keyPrimaryIsReleased = False

    return

def dSparky(self, obj):
    self.screen.blit(self.npcPoniesImage, (self.ox[obj] - self.camera.x - 32, self.oy[obj] - self.camera.y - 32), (1*96, 0, 96, 80))
    return

def uWeaponShopOutsideDoor(self, obj, game):
    if touching(self, obj):
        if(self.day == 6):
            self.createDialogBox(self.portraits[0], "Rosewind: It's closed due to the weather.")
            self.p1y += 3
            return
        self.nextmap = maploader.WEAPONSHOP
        self.os[obj] = 0
    return

def uWeaponShopInsideDoor(self, obj, game):
    if touching(self, obj):
        self.nextmap = maploader.MAINSTREET
        self.os[obj] = 0
    return

def uEmbersong(self, obj, game):

    if(self.day == 1):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[7], "Embersong : Hello there! Melody, have you been practicing?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[1], "Melody: Oh, yes, sir. Every day.")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 4
            self.createDialogBox(self.portraits[7], "Good filly! If you come back later, I'll have something for you.")
        if( self.os[obj] == 4 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[1], "Melody : Thank you, sir.")

    if(self.day == 2):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[7], "Embersong: I told you I'd have something for you, Melody. Do you want to take a look at all the instruments I have?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[7], "Embersong: Very well, I'll see you later. Don't forget to practice!")

    if(self.day == 3):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[7], "Embersong: Now that's what I call a storm! All this humidity is bad for wood instruments. How can I help you?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[7], "Embersong: Very well, I'll see you later. Don't forget to practice!")

    if(self.day == 4 or self.day == 5 or self.day == 6):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[7], "Embersong: Why, if it isn't our little hero! Are you looking for a new instrument?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[7], "Embersong: Practice makes perfect, so keep it up!")


    if(self.day == 7):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[7], "Embersong: I heard all about your quest. I'm thinking of writing an epic song about your exploits! But of course, I will have to wait until it's all over before, and I must help you in any way I can.")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[7], "Embersong: You have to tell me everything once it's all over!")


    if(self.day == 8):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[7], "Embersong: Why, if it isn't our little hero! Are you looking for a new instrument?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[7], "Embersong: Practice makes perfect, so keep it up!")

    if(self.day == 9):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[7], "Embersong: Hmm? Oh... I'm sorry. This darkness is making me sleepy. Can I help you?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[7], "Embersong: Run along now... yawn...")


            
    return

def dEmbersong(self, obj):
    self.screen.blit(self.npcPoniesImage, (self.ox[obj] - self.camera.x - 32, 32 + self.oy[obj] - self.camera.y - 32), (3*96, 0, 96, 80))
    return

def uIronhoof(self, obj, game):

    if(self.day == 1):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[10], "Ironhoof: Well well, what are the three of you doing in here?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[0], "Rosewind: I just thought we'd say hi!")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 4
            self.createDialogBox(self.portraits[10], "Ironhoof: Bah. Come see me when you need something!")
        if( self.os[obj] == 4 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[2], "Moonfire: What a grump.")

    if(self.day == 2):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[10], "Ironhoof: So, are you going to buy anything today, or are you going to stand around and waste my time?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[10], "Ironhoof: Right, now go away.")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[2], "Moonfire: Sheesh. What a grouch.")

    if(self.day == 3):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[10], "Ironhoof: This is no weather to go traipsing around outdoors. Do you need anything?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[10], "Ironhoof: Try not to drip all over my floor.")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[2], "Moonfire: I still think he's a grouch.")

    if(self.day == 4):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[10], "Ironhoof: So, are you going to buy anything today, or are you going to stand around and waste my time?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[10], "Ironhoof: Right, now go away.")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[2], "Moonfire: Sheesh. What a grouch.")

    if(self.day == 5):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[10], "Ironhoof: So, are you going to buy anything today, or are you going to stand around and waste my time?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[10], "Ironhoof: Right, now go away.")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[2], "Moonfire: What a hardcase!")

    if(self.day == 6 or self.day == 7):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[10], "Ironhoof: These quakes are going to cause a lot of damage to the town. Hurry up and buy something, I'll have a lot of work to do!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[10], "Ironhoof: Good. Now get going!")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[2], "Moonfire: He's so bad-tempered.")

    if(self.day == 8):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[10], "Ironhoof: So, are you going to buy anything today, or are you going to stand around and waste my time?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[10], "Ironhoof: Right, now go away.")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[2], "Moonfire: Sheesh. What a grouch.")


    if(self.day == 9):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[10], "Ironhoof: Look at these ponies, no one's lifting a hoof to do anything! At least you're trying to help. ")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[10], "Ironhoof: Go, now! ...be careful.")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[2], "Moonfire: ...did he just say that?")
            
    return

def dIronhoof(self, obj):
    self.screen.blit(self.npcPoniesImage, (16 + self.ox[obj] - self.camera.x - 32, self.oy[obj] - self.camera.y - 32), (6*96, 80, 96, 80))
    return

def dEmbersong(self, obj):
    self.screen.blit(self.npcPoniesImage, (self.ox[obj] - self.camera.x - 32, 32 + self.oy[obj] - self.camera.y - 32), (3*96, 0, 96, 80))
    return

def uStarseeker(self, obj, game):

    if (self.day == 1):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[9], "Starseeker: This just doesn't look good... mmh...")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[0], "Rosewing: Is there a problem, miss Starseeker?")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 4
            self.createDialogBox(self.portraits[9], "Starseeker: Oh! No, well, not one you would understand. All these clouds... I keep having this dreadful, dreadful feeling about them. It's probably nothing to worry about, but...")
        if( self.os[obj] == 4 and self.isShowingDialogBox == False):
            self.os[obj] = 5
            self.createDialogBox(self.portraits[2], "Moonfire: We're going to do something about that, don't worry.")
        if( self.os[obj] == 5 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[9], "Starseeker: I wouldn't want to trouble you about it! But your diligence is admirable, Moonfire. If only you could be this eager about your studies...")

    if (self.day == 2):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[9], "Starseeker: You are leaving already, Moonfire? Well, I can't say I blame you... But before you go, please take a spellbook with you. You don't want to be taken by surprise again.")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[9], "Starseeker: Don't neglect your studies!")

    if (self.day == 3):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[9], "Starseeker: With all this rain, my basement is getting flooded! Let me tell you, young ones: Books and water do NOT mix well. I'd better let you have some of these before they get too wet.")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[9], "Starseeker: Take care, now, young ones!")

    if (self.day == 4):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[9], "Starseeker: Magic is a serious field of study. You can't just pick up a book and say the magic words! A good book can make a great difference.")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[9], "Starseeker: Do tell Moonfire to pay more attention to his lectures, will you?")

    if (self.day == 5):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[9], "Starseeker: Magic is a serious field of study. You can't just pick up a book and say the magic words! A good book can make a great difference.")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[9], "Starseeker: Do tell Moonfire to pay more attention to his lectures, will you?")

    if (self.day == 7):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[9], "Starseeker: I looked over Moonfire's collected data about elementals. Very interesting! Very dangerous as well. You need all the equipment I can provide.")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[9], "Starseeker: Be careful, young ones.")

    if (self.day == 8):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[9], "Starseeker: Magic is a serious field of study. You can't just pick up a book and say the magic words! A good book can make a great difference.")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[9], "Starseeker: Do tell Moonfire to pay more attention to his lectures, will you?")

    if (self.day == 9):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[9], "Starseeker: I've always been more of a night pony, to be honest, but this is a real problem! There is something hugely magical in town, I can feel it, and it's giving me quite a headache.")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[9], "Starseeker: Ugh... my head...")

    return

def dStarseeker(self, obj):
    self.screen.blit(self.npcPoniesImage, (64 + self.ox[obj] - self.camera.x - 32, 32 + self.oy[obj] - self.camera.y - 32), (5*96, 0, 96, 80))
    return

def uAccessoryShopOutsideDoor(self, obj, game):
    if touching(self, obj):
        self.nextmap = maploader.ACCESSORYSHOP
        self.os[obj] = 0
    return

def uAccessoryShopInsideDoor(self, obj, game):
    if touching(self, obj):
        self.nextmap = maploader.MAINSTREET
        self.os[obj] = 0
    return

def uVanilly(self, obj, game):

    if(self.day == 1):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[6], "Vanilly: Rosewind! It's so delightful to see you, my love! I see you are wearing that RIBBON I made!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[0], "Rosewind: I'm glad to see you too, Vanilly. What do you have in stock today?")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 4
            self.createDialogBox(self.portraits[6], "Vanilly: Ah, unfortunately I ran out of fabric for my next creation, and the next shipment hasn't arrived yet. I'm afraid you will have to come back later.")
        if( self.os[obj] == 4 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[0], "Rosewind: I'll make sure to come by!")

    if(self.day == 2):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[6], "Vanilly: Darling!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[0], "Rosewind: Hey, Vanilly! Isn't it a wonderful day?")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 4
            self.createDialogBox(self.portraits[6], "Vanilly: I wouldn't say so. This harsh sunlight is bad for your skin, you know. Oh, now I wish we had those clouds back!")
        if( self.os[obj] == 4 and self.isShowingDialogBox == False):
            self.os[obj] = 5
            self.createDialogBox(self.portraits[0], "Rosewind: I don't think it's quite that bad. So, may I ask what you have in stock?")
        if( self.os[obj] == 5 and self.isShowingDialogBox == False):
            self.os[obj] = 6
            self.createDialogBox(self.portraits[6], "Vanilly: Oh, of course, of course! Here.")
        if( self.os[obj] == 6 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[6], "Vanilly: Have a pleasant day!")

    if(self.day == 3):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[6], "Vanilly: Oh my! Come dry yourselves! You're so brave to go out in this terrible weather. I don't know how you can do it!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[6], "Vanilly: Thankfully, today's special item is waterproof!")

    if(self.day == 4):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[6], "Vanilly: Hello, my darling! You HAVE to try on my latest creation!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[6], "Vanilly: Excellent choice! My dear, you have exquisite taste.")

    if(self.day == 5 and True):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[6], "Vanilly: Hello, my darling! You HAVE to try on my latest creation!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[6], "Vanilly: Excellent choice! My dear, you have exquisite taste.")

    if(self.day == 5 and False):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[6], "Vanilly: Oh, Rosewind, that is so nice of you! I didn't even hear the sign fall off! I'm so grateful, I will give you a discount!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[6], "Vanilly: Excellent choice! My dear, you have exquisite taste.")

    if(self.day == 6):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[6], "Vanilly: Oh, honey, my nerves are so frazzled right now! I must look terrible!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[0], "Rosewind: Of course not, you're just as lovely as usual!")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 4
            self.createDialogBox(self.portraits[6], "Vanilly: It's so sweet of you to say so, dear. Ah, but what was I thinking? I can't waste your time with idle chit-chat! You are here to see my latest creations, correct?")
        if( self.os[obj] == 4 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[0], "Vanilly: Excellent choice! My dear, you have exquisite taste.")

    if(self.day == 7):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[6], "Vanilly: Hello, my darling! You HAVE to try on my latest creation!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[6], "Vanilly: Excellent choice! My dear, you have exquisite taste.")

    if(self.day == 8):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[6], "Vanilly: Oh, my darlings! Am I ever so glad to see you! All this gloominess is getting to me. ")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[6], "Vanilly: I heard you were trying to take care of all this HORRIBLE weather. Is it true?")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[0], "Rosewind: We hope so. ")

    return

def dVanilly(self, obj):
    self.screen.blit(self.npcPoniesImage, (64 + self.ox[obj] - self.camera.x - 32, 32 + self.oy[obj] - self.camera.y - 32), (2*96, 0, 96, 80))
    return

def uBakeryOutsideDoor(self, obj, game):
    if touching(self, obj):
        self.nextmap = maploader.BAKERY
        self.os[obj] = 0
    return

def uBakeryInsideDoor(self, obj, game):
    if touching(self, obj):
        self.nextmap = maploader.MAINSTREET
        self.os[obj] = 0
    return

def uButterbell(self, obj, game):

    if( self.day == 1):
        if touching(self, obj):
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[4], "Butterbell: Why hello, Rosewind! How can I serve you?")
                game.mykeys.keyPrimaryIsReleased = False
                self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[4], "Butterbell : Thank you for coming!")

    if( self.day == 2):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[4], "Butterbell: Hello, hello! Today's special is muffins! What will it be?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[4], "Butterbell : Thank you for coming!")

    if(self.day == 3):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[4], "Butterbell: Nothing is more comforting after braving the rain than an apple. So, how can I help you today?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[4], "Butterbell : Thank you for coming!")

    if(self.day == 4):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[4], "Butterbell: Hello, hello! Today's special is apples! What will it be?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[4], "Butterbell : Thank you for coming!")

    if(self.day == 5):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[4], "Butterbell: Hello, hello! Today's special is cupcakes! What will it be?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[4], "Butterbell : Thank you for coming!")

    if(self.day == 6):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[4], "Butterbell: That's right, we're open in any weather! So, how can I help you?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[4], "Butterbell : Thank you for coming!")

    if(self.day == 7):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[4], "Butterbell: I'm normally pretty hard to shake, but that earthquake was something! Still, business must go on. How can I help you?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[4], "Butterbell : Thank you for coming!")

    if(self.day == 8):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[4], "Butterbell: Hello, hello! Today's special is pies! What will it be?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[4], "Butterbell : Thank you for coming!")

    if(self.day == 9):
        if touching(self, obj):
          if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[4], "Butterbell: Normally, people are flocking in at this hour to get their breakfast, but it's so dark outside... it's like night-time.")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[4], "Butterbell: Thank you for coming. Should I be worried?")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.createDialogBox(self.portraits[1], "Rosewind: I... I don't know yet.")


    return

def dButterbell(self, obj):
    self.screen.blit(self.npcPoniesImage, (16 + self.ox[obj] - self.camera.x - 32, self.oy[obj] - self.camera.y - 32), (0*96, 0, 96, 80))
    return

def uDay1TowerLockedCutscene(self, obj, game):
    if( self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.createDialogBox(self.portraits[1], "Melody: There it is...")
    if( self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 3
        self.createDialogBox(self.portraits[2], "Moonfire: I have a strange feeling about this.")
    if( self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.os[obj] = 4
        self.createDialogBox(self.portraits[0], "Rosewind: What do you mean?")
    if( self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.os[obj] = 0
        self.freeze = False
        self.progression = 6
        self.createDialogBox(self.portraits[2], "Moonfire: I don't know. It's just a... strange feeling. Let's go inside.")
    return

def uTowerOutsideDoor(self, obj, game):

    if(self.day == 1):
        if touching(self, obj):
            if self.progression >= 8 and self.day == 1:
                self.nextmap = maploader.TOWER
                self.towerlevel = 1
                self.towerentrance = 0
            if self.progression == 6:
                self.os[obj] = 2
                self.progression += 1
                self.createDialogBox(self.portraits[0], "Rosewind: It's locked!")
            if( self.os[obj] == 2 and self.isShowingDialogBox == False):
                self.createDialogBox(self.portraits[1], "Melody: I guess we'll have to ask Silverflake for the key, then...")
                self.os[obj] = 3
            if( self.os[obj] == 3 and self.isShowingDialogBox == False):   
                self.createDialogBox(self.portraits[0], "Rosewind: Yeah. His house is on the outskirts of the village. Let's go.")
                self.os[obj] = 0

    if(self.day == 2 and self.progression < 104):
        if touching(self, obj):
            self.createDialogBox(self.portraits[0], "Rosewind: It's locked...")
            self.p1y += 3

    if(self.day == 2 and self.progression >= 104):
        if touching(self, obj):
            self.nextmap = maploader.TOWER
            self.towerlevel = 1
            self.towerentrance = 0

    if(self.day == 3 or self.day == 5 or self.day == 6 or self.day == 7 or self.day == 8 or self.day == 9):
        if touching(self, obj):
            self.nextmap = maploader.TOWER
            self.towerlevel = 1
            self.towerentrance = 0

    if(self.day == 4 and self.progression < 313):
        if touching(self, obj):
            self.createDialogBox(self.portraits[0], "Rosewind: Oh, that's right, I gave the key back to Silverflake! We'll have to convince him to let us in.")
            self.p1y += 3

    if(self.day == 4 and self.progression >= 313):
        if touching(self, obj):
            self.nextmap = maploader.TOWER
            self.towerlevel = 1
            self.towerentrance = 0
        

    return

def uSilverflakeOutsideDoor(self, obj, game):
    if(self.day == 1 or self.day == 2):
        if touching(self, obj):
            home = False
            if(self.progression == 7):
                self.oid[self.o] = DAY1_SILVERFLAKEDOORCUTSCENE
                self.ox[self.o] = 0 * 32
                self.oy[self.o] = 0 * 32
                self.ow[self.o] = 0 * 32
                self.oh[self.o] = 0
                self.os[self.o] = 1
                self.o = self.o + 1
                self.progression = 8
                home = True
            if(home == False):
                self.createDialogBox(self.portraits[0], "*knock knock* No one seems to be home.")
                self.p1y += 3

    if(self.day == 3):
        if touching(self, obj):
            home = False
            if(self.progression == 202):
                self.nextmap = maploader.SILVERFLAKEHOUSE
                self.os[obj] = 0
                home = True
            if(self.progression > 202):
                self.createDialogBox(self.portraits[0], "Melody: I don't think we should go back...")
                self.p1y += 3 
                home = True
            if(home == False):
                self.createDialogBox(self.portraits[0], "I don't want to bother Silverflake right now.")
                self.p1y += 3    

    if(self.day == 4):
        if touching(self, obj):
            if(self.progression < 310):
                self.createDialogBox(self.portraits[0], "Melody: Hmm... Maybe I shouldn't bother him now.")
                self.os[obj] = 0
            if(self.progression >= 310):
                self.nextmap = maploader.SILVERFLAKEHOUSE
                self.os[obj] = 0

    if(self.day == 5 or self.day == 6 or self.day == 7 or self.day == 8):
        if touching(self, obj):
            self.nextmap = maploader.SILVERFLAKEHOUSE
            self.os[obj] = 0

    if(self.day == 9):
        if touching(self, obj):
            self.createDialogBox(self.portraits[0], "Melody: There's a note on the door... \nHe's gone to the tower!")
            self.os[obj] = 1
            self.p1y += 3

    return

def uDay1SilverflakeDoorCutscene(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[0], "Rosewind: Oh! It looks like Silverflake's not there right now...")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: There's a note on the door.")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: ''Out of town - I will be back Sunday.''")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: No way am I waiting that long! Melody, it looks like the top floor window is open. Can you go in and look for the key?")
        self.os[obj] = 5
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: That would be wrong!")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: I agree with him, though. If the tower's not working right, someone has to go fix it.")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Oh, I guess you're right...")
        self.os[obj] = 8
        self.ox[obj] = 0
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.player.hasMelody = False
        self.ox[obj] += 1
        if(self.ox[obj] >= 200):
            self.player.hasMelody = True
            self.os[obj] = 12
            self.createDialogBox(self.portraits[1], "Melody: I found it. It still feels kind of bad to take something from someone's home like this.")
    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.os[obj] = 13
        self.createDialogBox(self.portraits[0], "Rosewind: We'll put it back when we're done.")
    if(self.os[obj] == 13 and self.isShowingDialogBox == False):
        self.os[obj] = 14
        self.createDialogBox(self.portraits[0], "(Picked up the first floor key!)\n(You can now enter the tower)")
        self.freeze = False
    return

def uDay1TowerIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[2], "Moonfire: I have a really, really weird feeling...")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: I think I can feel it too. Something isn't right!")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Oh... I think we're not alone in here...")
        self.os[obj] = 0
        self.freeze = False
    return

def uTowerLowerExit(self, obj, game):
    if touching(self, obj):
        if(self.towerlevel == 1):
            self.nextmap = maploader.TOWEROUTSIDE
            self.os[obj] = 0
        else:
            self.nextmap = maploader.TOWERBOSS
            self.towerlevel -= 1
            self.towerentrance = 1
            self.os[obj] = 0
    return

def uTowerHigherExit(self, obj, game):
    if touching(self, obj):
            self.nextmap = maploader.TOWERBOSS
            self.towerentrance = 0
            self.os[obj] = 0
    return

def uTowerBossLowerExit(self, obj, game):
    if touching(self, obj):
            self.nextmap = maploader.TOWER
            self.towerentrance = 1
            self.os[obj] = 0
    return

def uTowerBossHigherExit(self, obj, game):
    if touching(self, obj):
        if(self.towerlevel == 9):
            self.nextmap = maploader.REALROOF
            self.os[obj] = 0
        else:
            self.nextmap = maploader.TOWER
            self.towerentrance = 0
            self.towerlevel += 1
            self.os[obj] = 0
    return    

def uDay1BossIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.createDialogBox(self.portraits[0], "Rosewind: This should be the CLOUD ENGINE room. \nLook! That's where these weird monsters are coming from!")

    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 3
        self.createDialogBox(self.portraits[2], "Moonfire: Woah, the magic levels in this room are really high. No wonder I felt weird!")

    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.os[obj] = 4
        self.createDialogBox(self.portraits[0], "Rosewind: We have to stop this machine! ")

    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[2], "Moonfire: Good idea, the magic should dissipate right away.")

    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.os[obj] = 6
        self.createDialogBox(self.portraits[1], "Melody: How do we do this?")

    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.os[obj] = 7
        self.createDialogBox(self.portraits[0], "Rosewind: I'll go take a closer look.")

    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.p1y -= 3
        self.p1anim += 1
        if(self.p1y < 17 * 32):
            self.p1y = 17 * 32
            self.p1dir = 2
            self.p1x += 3
            self.p1anim += 1
            if(self.p1x > 20 * 32):
                self.p1x = 20 * 32
                self.os[obj] = 8



    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Rosie! LOOK OUT!")
        self.os[obj] = 9

    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: What was that thing?")
        self.os[obj] = 11

    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.p2follow = False
        self.p3follow = False
        self.p2y = self.p1y
        self.p3y = self.p1y
        self.p2x = self.p1x - 32
        self.p3x = self.p1x - 64
        self.p2dir = 2
        self.p3dir = 2
        self.os[obj] = 10
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Whatever it was, it's gone now...?")
        self.os[obj] = 12

    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: I don't like this.")
        self.os[obj] = 13

    if(self.os[obj] == 13 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: But we defeated it, didn't we? Now we can have our picnic!")
        self.os[obj] = 14

    if(self.os[obj] == 14 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: I know. You two go ahead, I'll be right behind you.")
        self.os[obj] = 15

    if(self.os[obj] == 15 and self.isShowingDialogBox == False):
        self.p1y += 2
        self.p1anim += 1
        self.p1dir = 3
        if(self.p1y - 32 > self.p2y):
            self.p2y += 2
            self.p2dir = 3
            self.p2anim += 1
            self.os[obj] = 16
        if(self.p1y >= 25 * 32):
            self.p1y = 25 * 32
        if(self.p2y >= 25 * 32):
            self.p2y = 25 * 32

    if(self.os[obj] == 16):
        self.p1y += 2
        self.p1anim += 1
        self.p1dir = 3
        self.p2y += 2
        self.p2dir = 3
        self.p2anim += 1
        if(self.p1y >= 25 * 32):
            self.p1y = 25 * 32
        if(self.p2y >= 25 * 32):
            self.p2y = 25 * 32
            self.nextmap = maploader.TOWERROOF
            self.os[obj] = 0
            self.freeze = False
    return

def dDay1BossIntro(self, obj):
    return

def uBossMachine(self, obj, game):
    self.os[obj] += 1
    if(self.os[obj] > 90):
        self.os[obj] = 1
    return

def dBossMachine(self, obj):
    frame = (self.os[obj] / 10)%2
    if(self.os[obj] == 100):
        frame = 2
    self.screen.blit(self.machineImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (0, 96*frame, 128, 96))
    return

def uOrb(self, obj, game):
    if(self.os[obj] == self.day and self.nextmap == 0):
        self.ow[obj] += 1
        if(self.ow[obj] == 300):
            self.freeze = False
            if(self.day != 9):
                self.nextmap = maploader.ROSEWINDHOUSE
            if(self.day == 9):
                self.nextmap = maploader.ENDBOSS
    return

def dOrb(self, obj):
    if(self.os[obj] > self.day):
        if(self.os[obj] != 9):
            self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (32 * (self.os[obj] - 1), 32, 32, 64))
        else:
            self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (0, 96, 32, 64))
    if(self.os[obj] < self.day):
        self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (32, 96, 32, 64))

    if(self.os[obj] == self.day):
        csize = 500 - self.ow[obj]*2
        if(csize >= 1):
            self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (32 * (self.os[obj] - 1), 32, 32, 64))
            pygame.draw.circle(self.screen, (255, 255, 255), (self.ox[obj] - self.camera.x + 16, self.oy[obj] - self.camera.y + 16), csize, 2)
        else:
            self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (32, 96, 32, 64))
 
    return

def uWarp(self, obj, game):
    if touching(self, obj):
      if game.mykeys.keyPrimaryIsReleased == True:
        if self.os[obj] < 10:
            self.towerentrance = 2
            self.towerlevel = self.os[obj]
            self.nextmap = maploader.TOWERBOSS
        if self.os[obj] == 10:
            self.towerentrance = 2
            self.towerlevel = 1
            self.nextmap = maploader.TOWER
    return

def dWarp(self, obj):
    self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (64, 96, 64, 64))
    return

def uOutsideMelodyDoor(self, obj, game):

    if(self.day == 1 or self.day == 4 or self.day == 5 or self.day == 6 or self.day == 7 or self.day == 8 or self.day == 9):
        if touching(self, obj):
            self.createDialogBox(self.portraits[0], "Rosewind: Melody's outside already.")
            self.p1y += 3

    if(self.day == 2):
        if touching(self, obj):
            self.createDialogBox(self.portraits[0], "Rosewind: It's too nice outside to stay cooped up inside!")
            self.p1y += 3

    if(self.day == 3 and self.progression == 201):        
        if touching(self, obj) and self.os[obj] == 1:
            self.createDialogBox(self.portraits[1], "Melody: Hey Rosewind! Don't stand in the rain, come on in.")
            self.os[obj] = 2
        if self.os[obj] == 2 and self.isShowingDialogBox == False:
            self.nextmap = maploader.MELODYHOUSE
            self.os[obj] = 0

    if(self.day == 3 and self.progression > 201):
        if touching(self, obj):
            self.nextmap = maploader.MELODYHOUSE
            self.os[obj] = 0

    return

def uOutsideRosewindDoor(self, obj, game):
    if touching(self, obj):
        self.p1y += 3
        specific = False
        if(self.day == 2):
            self.createDialogBox(self.portraits[0], "Rosewind: It's too nice outside to stay cooped up inside!")
            specific = True
        if(specific == False):
            self.createDialogBox(self.portraits[0], "Rosewind: We can't go back home now, we've got work to do!.")
            
        
    return


def uDay2Melody(self, obj, game):
    if touching(self, obj) and self.os[obj] == 1:
        if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[1], "Melody: Oh, hey Rosewind!")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
    if( self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 3
        self.createDialogBox(self.portraits[0], "Rosewind: You're not too busy today, are you?")
    if( self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.os[obj] = 4
        self.createDialogBox(self.portraits[1], "Melody: No, I'm free.")
    if( self.os[obj] ==4 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[0], "Rosewind: Good! We should get Moonfire and go swimming!")
    if( self.os[obj] ==5 and self.isShowingDialogBox == False):
        self.os[obj] = 6
        self.createDialogBox(self.portraits[1], "Melody: Okay. He's probably talking with his tutor right now. Let's go to the Weapons shop!")
    if( self.os[obj] ==6 and self.isShowingDialogBox == False):
        self.os[obj] = 0
        self.player.hasMelody = True
        self.progression = 102
        self.p1xb = [(self.ox[obj] * i + self.p1x * (20 - i))/20 for i in range(40)]
        self.p1yb = [(self.oy[obj] * i + self.p1y * (20 - i))/20 for i in range(40)]
        
                         
    return

def dDay2Melody(self, obj):
    self.screen.blit(self.player.melody.idleLeft, (self.ox[obj] - self.camera.x - 32, self.oy[obj] - self.camera.y - 32))
    return

def uDay2MoonfireCutscene(self, obj, game):
    if(self.os[obj] == 1):
        self.player.hasMoonfire = True
        self.p3follow = False
        self.freeze = True
        self.p3x = self.ox[obj]
        self.p3y = self.oy[obj]
        self.os[obj] = 2
        self.p3dir = 0
    if(self.os[obj] == 2):
        self.p3x -= 3
        self.p3anim += 1
        if(self.p3x <= 19 * 32):
            self.p3x = 19 * 32
            self.os[obj] = 3
    if(self.os[obj] == 3):
        self.p3y += 3
        self.p3dir = 3
        self.p3anim += 1
        if(self.p3y >= 24 * 32):
            self.p3y = 24 * 32
            self.os[obj] = 4
            self.p3anim = 0
            self.createDialogBox(self.portraits[2], "Moonfire: Rosewind! Didn't think I'd see you around today, everyone's hanging out in the sun. It's so HOT in here, wish I could be outside too.")
    if( self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[0], "Rosewind: Yes, Melody and I are going swimming later. Can't you come with us?")
    if( self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.os[obj] = 6
        self.createDialogBox(self.portraits[2], "Moonfire: Well...")
    if( self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.os[obj] = 7
        self.createDialogBox(self.portraits[1], "Melody: Please?")
    if( self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.os[obj] = 8
        self.createDialogBox(self.portraits[2], "Moonfire: Heh, all right. There's no point in practicing fire spells on such a hot day, is there?")
    if( self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.p3y += 3
        if(self.p3y >= self.p1y):
            self.p3y = self.p1y
            self.os[obj] = 0
            self.p3follow = True
            self.freeze = False
            self.progression = 103


    return

def uDay2BusybeeCutscene(self, obj, game):
    if(self.os[obj] == 1):
        self.p1x = 24 * 32
        self.p2x = 23 * 32
        self.p3x = 22 * 32
        self.p1y = 22 * 32
        self.p2y = 23 * 32
        self.p3y = 24 * 32
        self.p1dir = 2
        self.p2dir = 2
        self.p3dir = 2
        self.p2follow = False
        self.freeze = True
        self.p3follow = False
        self.createDialogBox(self.portraits[8], "Busybee: I'm afraid you can't go to the lake right now, Rosewind.")
        self.os[obj] = 2
    if( self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 3
        self.createDialogBox(self.portraits[0], "Rosewind: What? Why?")
    if( self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.os[obj] = 4
        self.createDialogBox(self.portraits[8], "Busybee: The water's all dried up. It's, the sunlight, making all the water evaporate!")
    if( self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[0], "Rosewind: Wow, that sounds bad.")
    if( self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.os[obj] = 6
        self.createDialogBox(self.portraits[8], "Busybee: And that's not the worst of it. My fields aren't doing so hot. The sun's burning up my crops!")       
    if( self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.os[obj] = 7
        self.createDialogBox(self.portraits[0], "Melody: That's terrible")
    if( self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.os[obj] = 8
        self.createDialogBox(self.portraits[8], "Busybee: Yes, I sure wish we had some rain.")
    if( self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.p1x += 3
        self.p1anim += 1
        self.p2x += 3
        self.p2anim += 1
        self.p3x += 3
        self.p3anim += 1
        if(self.p1x > 36 * 32):
            self.os[obj] = 9
            self.p1anim = 0
            self.p2anim = 0
            self.p3anim = 0
            self.createDialogBox(self.portraits[2], "Moonfire: No lake? ")
    if( self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.os[obj] = 10
        self.createDialogBox(self.portraits[1], "Melody: And no crops?")
    if( self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.os[obj] = 11
        self.createDialogBox(self.portraits[0], "Rosewind: You're right, that's really bad. Maybe we shouldn't have broken the cloud machine!")
    if( self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.os[obj] = 12
        self.createDialogBox(self.portraits[2], "Moonfire: I think there's more to this than it looks. We should go back to the tower.")
    if( self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.os[obj] = 13
        self.createDialogBox(self.portraits[1], "Melody: Silverflake's not back home yet, though. I'm not sneaking in there again!")
    if( self.os[obj] == 13 and self.isShowingDialogBox == False):
        self.p1x += 3
        self.p1anim += 1
        self.p2x += 3
        self.p2anim += 1
        self.p3x += 3
        self.p3anim += 1
        if(self.p1x > 41 * 32):
            self.os[obj] = 14
            self.p1anim = 0
            self.p2anim = 0
            self.p3anim = 0
            self.createDialogBox(self.portraits[0], "Rosewind: Actually... I kind of forgot to put the key back yesterday.")
    if( self.os[obj] == 14 and self.isShowingDialogBox == False):
        self.os[obj] = 15
        self.createDialogBox(self.portraits[1], "Melody: Rosewind!")
    if( self.os[obj] == 15 and self.isShowingDialogBox == False):
        self.os[obj] = 16
        self.createDialogBox(self.portraits[2], "Moonfire: Nothing's keeping us, then. Let's go!")
    if( self.os[obj] == 16 and self.isShowingDialogBox == False):
        self.p1xb = [(self.p3x * i + self.p1x * (40 - i))/40 for i in range(40)]
        self.p1yb = [(self.p3y * i + self.p1y * (40 - i))/40 for i in range(40)]
        self.p1db = [self.p1dir for i in range(40)]
        self.freeze = False
        self.progression = 104
        self.os[obj] = 0
        self.p2follow = True
        self.p3follow = True
    return

def uDay2LevelIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[1], "Melody: Oh... it's so hot in here.")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: No kidding! And so bright, too!")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: It's kind of pretty, though.")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Girls, we've got company!")
        self.os[obj] = 0
        self.freeze = False
        self.progression = 106
    return


def uDay2BossIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.p2follow = False
        self.p3follow = False
        self.p1x = 18 * 32
        self.p1y = 24 * 32
        self.p3x = 19 * 32
        self.p3y = 23 * 32
        self.p2x = 20 * 32
        self.p2y = 24 * 32
        self.p1dir = 1
        self.p2dir = 1
        self.p3dir = 1
        self.createDialogBox(self.portraits[0], "Rosewind: Here's the SUN FOCUSSOR ROOM. \nI think we're here... and not a moment too soon!")

    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 3
        self.createDialogBox(self.portraits[1], "Melody: I... can't take it any longer.")

    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.os[obj] = 4
        self.createDialogBox(self.portraits[2], "Moonfire: I'm afraid you'll have to...")
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.p3y -= 3
        self.p3anim += 1
        if(self.p3y < 17 * 32):
            self.p3y = 17 * 32
            self.p3dir = 2
            self.p3x += 3
            self.p3anim += 1
            if(self.p3x > 20 * 32):
                self.p3x = 20 * 32
                self.os[obj] = 5
                self.p3anim = 0
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: ...because I don't think THAT'S going to let us just trot by!")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.os[obj] = 20
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Whew, I feel cooler already without that thing in the room!")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: More of that... magic energy stuff. Let's hope that's over for good!")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Yes. Let's hope so.")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: But... let's be on our guard.")
        self.os[obj] = 10

    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
            self.nextmap = maploader.TOWERROOF
            self.os[obj] = 0
            self.freeze = False
    return

def uMelodyHouseInsideDoor(self, obj, game):
    if touching(self, obj):
        self.nextmap = maploader.OUTSKIRTS
        self.os[obj] = 0
        
    return

def uDay3MelodyHouseCutscene(self, obj, game):
    if(self.os[obj] == 1):
        self.player.hasMoonfire = True
        self.player.hasMelody = True
        self.p3follow = False
        self.freeze = True
        self.p2follow = False
        self.p3x = 18 * 32
        self.p3y = 16 * 32
        self.p3dir = 0
        self.p2x = 15 * 32
        self.p2y = 19 * 32
        self.p2anim = 0
        self.p3anim = 0
        self.p2dir = 2
        self.os[obj] = 2
        self.p1dir = 1
        self.createDialogBox(self.portraits[2], "Moonfire: Mmn. Hey Rosie.")
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Wow, you're really out of it today. What's wrong?")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: It's the rain. I just... don't like rain.")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: He looked so miserable outside, I had to invite him in.")
        self.os[obj] = 5
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Why were you outside?")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Well... it has something to do with the events in the Tower. I won't lie to you, I'm starting to feel a little worried.?")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Me too.")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Hmm. You're right. Both times, we saw all these monsters in the tower. That's just not normal.")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: They're elementals. Spirits that are formed when the magic concentration is too high. And let me tell you, they are bad news.")
        self.os[obj] = 10
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Maybe we should tell Silverflake about this, then.")
        self.os[obj] = 11
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: That's where I was headed.")
        self.os[obj] = 12
    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Oh, but why did you come to my house instead? His isn't very far from here.")
        self.os[obj] = 13 
    if(self.os[obj] == 13 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: I... I really hate the rain, all right?")
        self.os[obj] = 14
    if(self.os[obj] == 14 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: We shouldn't delay.")
        self.os[obj] = 15
    if(self.os[obj] == 15 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Bleh.")
        self.os[obj] = 16
    if(self.os[obj] == 16 and self.isShowingDialogBox == False):
        self.freeze = False
        self.p3follow = True
        self.p2follow = True
        self.hide = True
        self.nextmap = maploader.OUTSKIRTS
        self.os[obj] = 0
    return

def uDay3SilverflakeHouseCutscene(self, obj, game):
    if(self.os[obj] == 1):
        self.freeze = True
        self.p3follow = False
        self.p2follow = False
        self.os[obj] = 2
        self.ow[obj] = 3
        self.p2x = self.p1x - 32
        self.p2y = self.p1y + 32
        self.p3x = self.p1x + 32
        self.p3y = self.p1y + 32
        self.p1dir = 1
        self.p2dir = 1
        self.p3sir = 1

    if(self.os[obj] == 2):
        self.oy[obj] += 3
        self.oh[obj] += 1
        if(self.oy[obj] >= 21 * 32):
            self.oh[obj] = 0
            self.os[obj] = 3
            self.createDialogBox(self.portraits[3], "Silverflake: What are you three doing here?.")

    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Oh, sorry to bother you!")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: It's fine... Sorry. I'm just a little on edge right now. Someone broke in while I was away.")
        self.os[obj] = 5
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Oh. Um.")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Yeah, that was us, but...")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: What??")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: I'm sorry! It was an emergency!")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: So YOU'RE the one who messed with my Weather Tower!")
        self.os[obj] = 10
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: We were just trying to fix things!")
        self.os[obj] = 11
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: Fix things? You made them worse! Now there's this torrential downpour!")
        self.os[obj] = 12
    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: That's caused by your invention?")
        self.os[obj] = 13
    if(self.os[obj] == 13 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: I knew there was something weird about it! Come on, girls. We have to see!")
        self.os[obj] = 14
    if(self.os[obj] == 14 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: Hold on a minute! You can't just...")
        self.os[obj] = 15
    if(self.os[obj] == 15 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: We have to!")
        self.os[obj] = 16
    if(self.os[obj] == 16 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Wait, we'll need the key...")
        self.os[obj] = 17
    if(self.os[obj] == 17 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Ah... well, I still have it.")
        self.os[obj] = 18
    if(self.os[obj] == 18 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: You what??")
        self.os[obj] = 19
    if(self.os[obj] == 19 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: I'm sorry! I forgot!")
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Moonfire: Let's go, then!")
        self.os[obj] = 21
    if(self.os[obj] == 21 and self.isShowingDialogBox == False):
        self.p2x += 3
        self.p2dir = 2
        self.p2anim += 1
        self.p3x -= 3
        self.p3dir = 0
        self.p3anim += 1
        self.p1y += 3
        self.p1dir = 3
        self.p1anim += 1
        if(self.p2x >= self.p1x):
            self.os[obj] = 22
    if(self.os[obj] == 22 and self.isShowingDialogBox == False):
        self.p1y += 3
        self.p2y += 3
        self.p3y += 3
        self.p1anim += 1
        self.p2anim += 1
        self.p3anim += 1
        self.p1dir = 3
        self.p2dir = 3
        self.p3dir = 3
        if(self.p1y >= 27 * 32):
            self.os[obj] = 23
            self.hide = True
            self.createDialogBox(self.portraits[3], "Silverflake: COME BACK HERE!")
    if(self.os[obj] == 23):
        self.ox[obj] -= 3
        self.oh[obj] += 1
        self.ow[obj] = 0
        if(self.ox[obj] <= 15 * 32 + 8):
            self.os[obj] = 24
    if(self.os[obj] == 24):
        self.oy[obj] += 3
        self.oh[obj] += 1
        self.ow[obj] = 3
        if(self.oy[obj] >= 27 * 32):
            self.os[obj] = 25
        
    if(self.os[obj] == 25 and self.isShowingDialogBox == False):
        self.freeze = False
        self.p3follow = True
        self.p2follow = True
        self.nextmap = maploader.OUTSKIRTS
        self.os[obj] = 0
    return

def dDay3SilverflakeHouseCutscene(self, obj):
    frame = (self.oh[obj] / 6)%6
    if self.oh[obj] == 0:
        if self.ow[obj] == 0:
            srcx = 0
            srcy = 0
            self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32 - 4, self.oy[obj] - self.camera.y - 32 - 4), (srcx * 96,srcy * 80,96,80))
        if self.ow[obj] == 1:
            srcx = 0
            srcy = 2
            self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32 - 4, self.oy[obj] - self.camera.y - 32 - 4), (srcx * 96,srcy * 80,96,80))
        if self.ow[obj] == 2:
            srcx = 14
            srcy = 0
            self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32 - 4, self.oy[obj] - self.camera.y - 32 - 4), (srcx * 96,srcy * 80,96,80))
        if self.ow[obj] == 3:
            srcx = 0
            srcy = 1
            self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32 - 4, self.oy[obj] - self.camera.y - 32 - 4), (srcx * 96,srcy * 80,96,80))
    if self.oh[obj] > 0:
        if self.ow[obj] == 0:
            srcx = 1 + frame
            srcy = 0
            self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32 - 4, self.oy[obj] - self.camera.y - 32 - 4), (srcx * 96,srcy * 80,96,80))
        if self.ow[obj] == 1:
            srcx = 1 + frame
            srxy = 2
            self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32 - 4, self.oy[obj] - self.camera.y - 32 - 4), (srcx * 96,srcy * 80,96,80))
        if self.ow[obj] == 2:
            srcx = 7 + frame
            srcy = 0
            self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32 - 4, self.oy[obj] - self.camera.y - 32 - 4), (srcx * 96,srcy * 80,96,80))
        if self.ow[obj] == 3:
            srcx = 1 + frame
            srcy = 1
            self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32 - 4, self.oy[obj] - self.camera.y - 32 - 4), (srcx * 96,srcy * 80,96,80))

    return


def uDay3Flavour(self, obj, game):
    if(self.os[obj] == 1):
        self.freeze = True
        self.createDialogBox(self.portraits[0], "Rosewind: We come back here again. This rain is no better than yesterday's sun!")
        self.os[obj] = 2
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: You really shouldn't have angered Silverflake like this, though.")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: We'll apologize later. Let's go!")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.os[obj] = 0
        self.freeze = False
    return

def uDay3LevelIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[1], "Melody: Oh, that water looks deep.")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Don't complain. You have wings.")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Sorry...")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: The water currents feel... weird.")
        self.os[obj] = 5
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Elementals again. Watch where you step.")
        self.os[obj] = 0
        self.freeze = False
        self.progression = 212
    return


def uDay3BossIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.p2follow = False
        self.p3follow = False
        self.p1x = 19 * 32
        self.p1y = 21 * 32
        self.p3x = 18 * 32
        self.p3y = 22 * 32
        self.p2x = 20 * 32
        self.p2y = 22 * 32
        self.p1dir = 1
        self.p2dir = 1
        self.p3dir = 1
        self.createDialogBox(self.portraits[0], "Rosewind: Here is the RAIN CONDENSER room. \nThis is where the currents are the strongest!")

    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[2], "Moonfire: Yeah, and it's also where the biggest monster is!")
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Finally! Now we can dry out!")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Should we try to press on? We could just open the door.")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: I'm... I'm exhausted.")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Yeah, we should call it a day. I can create a portal here, though! If we have to come back, this would make a great shortcut.")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Well... I don't think Silverflake would like that.")
        self.os[obj] = 10
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Hmm... do it anyway. I think it might come in handy.")
        self.os[obj] = 11
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.nextmap = maploader.TOWERROOF
        self.os[obj] = 0
        self.freeze = False
    return


def uDay4Melody(self, obj, game):
    if touching(self, obj) and self.os[obj] == 1:
        if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[1], "Melody: Do you think it's finally over?")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
    if( self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 3
        self.createDialogBox(self.portraits[0], "Rosewind: Well, it looks this way.")
    if( self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.os[obj] = 4
        self.createDialogBox(self.portraits[1], "Melody: As alarming as the bad weather was... I thought it was kind of fun. It was like going on an adventure.")
    if( self.os[obj] ==4 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[0], "Rosewind: It wasn't ALL fun!")
    if( self.os[obj] ==5 and self.isShowingDialogBox == False):
        self.os[obj] = 6
        self.createDialogBox(self.portraits[1], "Melody: Oh, no, of course not. But I was happy to come with you.")
    if( self.os[obj] ==6 and self.isShowingDialogBox == False):
        self.os[obj] = 1  
                         
    return

def dDay4Melody(self, obj):
    self.screen.blit(self.player.melody.idleLeft, (self.ox[obj] - self.camera.x - 32, self.oy[obj] - self.camera.y - 32))
    return

def uDayLogo(self, obj, game):
    if( self.os[obj] < 100 and self.isShowingDialogBox == False):
        self.ow[obj] = (self.ow[obj] * 9 + 50)/10
        self.ox[obj] = (self.ox[obj] * 9 - 10)/10
        self.os[obj] += 1

    if( self.os[obj] >= 100 and self.isShowingDialogBox == False):
        self.ow[obj] -= self.oh[obj]
        self.ox[obj] -= self.oy[obj]
        self.oh[obj] += 0.20
        self.oy[obj] += 0.60
        self.os[obj] += 1

    if(self.os[obj] > 400):
        self.os[obj] = 0
        
    return

def dDayLogo(self, obj):
    pygame.draw.rect(self.screen, (0, 0, 0), (self.ox[obj] + 4, 180 + 3, 660, 5))
    self.screen.blit(self.daysImage, (self.ow[obj], 50), (0, (self.day - 1)*200, 400, 200))
    pygame.draw.rect(self.screen, (255, 255, 255), (self.ox[obj], 180, 660, 5))
    return

def uDay4Moonfire(self, obj, game):
    if touching(self, obj) and self.os[obj] == 1:
        if game.mykeys.keyPrimaryIsReleased == True:
            self.createDialogBox(self.portraits[2], "Moonfire: So, elementals can be caused... Oh, hey Rosewind! ")
            game.mykeys.keyPrimaryIsReleased = False
            self.os[obj] = 2
    if( self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 3
        self.createDialogBox(self.portraits[0], "Rosewind: Oh, sorry, go ahead, I didn't mean to interrupt you!")
    if( self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.os[obj] = 4
        self.createDialogBox(self.portraits[2], "Moonfire: It's fine, I'm getting bored of this research anyway. What brings you here?")
    if( self.os[obj] ==4 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[0], "Rosewind: I just thought I'd check up on you. After all, you looked a bit off yesterday.")
    if( self.os[obj] ==5 and self.isShowingDialogBox == False):
        self.os[obj] = 6
        self.createDialogBox(self.portraits[2], "Moonfire: Well, I'm fine now!")
    if( self.os[obj] ==6 and self.isShowingDialogBox == False):
        self.os[obj] = 7
        self.createDialogBox(self.portraits[0], "Rosewind: Yes, I'm happy to see that!")
    if( self.os[obj] ==7 and self.isShowingDialogBox == False):
        self.os[obj] = 1  
                         
    return

def dDay4Moonfire(self, obj):
    self.screen.blit(self.player.moonfire.idleRight, (self.ox[obj] - self.camera.x - 32, self.oy[obj] - self.camera.y - 32))
    return

def uDay4FogCutscene(self, obj, game):
    if( self.os[obj] == 1):
        self.os[obj] = 2
        self.player.hasMoonfire = True
        self.player.hasMelody = True
        self.p3follow = False
        self.freeze = True
        self.p2follow = False
        self.p2x = self.p1x + 32
        self.p3x = self.p2x + 32
        self.p2y = self.p1y + 32
        self.p3y = self.p2y + 32
        self.p3dir = 0
        self.p2dir = 0
        self.p1dir = 3
    if( self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 3
        self.createDialogBox(self.portraits[0], "Rosewind: What...")
    if( self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.os[obj] = 4
        self.createDialogBox(self.portraits[2], "Moonfire: What's going on in here??")
    if( self.os[obj] ==4 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[1], "Melody: Rosewind! Moonfire! I hoped I'd find you here!")
    if( self.os[obj] ==5 and self.isShowingDialogBox == False):
        self.os[obj] = 6
        self.createDialogBox(self.portraits[0], "Rosewind: How did it get so misty all of a sudden?")
    if( self.os[obj] ==6 and self.isShowingDialogBox == False):
        self.os[obj] = 7
        self.createDialogBox(self.portraits[2], "Moonfire: This isn't just mist, it's fog! I can barely see the tip of my tail!")
    if( self.os[obj] ==7 and self.isShowingDialogBox == False):
        self.os[obj] = 8
        self.createDialogBox(self.portraits[0], "Rosewind: I knew we were celebrating too soon!")
    if( self.os[obj] ==8 and self.isShowingDialogBox == False):
        self.os[obj] = 9
        self.createDialogBox(self.portraits[1], "Melody: Yes... it looks like we have to go back to the tower again.")
    if( self.os[obj] ==9 and self.isShowingDialogBox == False):
        self.os[obj] = 0
        self.freeze = False
        self.p2follow = True
        self.p3follow = True
        self.p1xb = [(self.p3x * i + self.p1x * (40 - i))/40 for i in range(40)]
        self.p1yb = [(self.p3y * i + self.p1y * (40 - i))/40 for i in range(40)]
                         
    return

def uSilverflake(self, obj, game):
    if(self.progression < 313):
        if touching(self, obj) and self.os[obj] == 1:
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[3], "Silverflake: You three again? Didn't you cause enough damage last time?")
                game.mykeys.keyPrimaryIsReleased = False
                self.os[obj] = 2
        if( self.os[obj] == 2 and self.isShowingDialogBox == False):
            self.os[obj] = 3
            self.createDialogBox(self.portraits[0], "Rosewind: Look! I know we shouldn't have taken the key while you weren't there... I'm really, really sorry about it.")
        if( self.os[obj] == 3 and self.isShowingDialogBox == False):
            self.os[obj] = 4
            self.createDialogBox(self.portraits[3], "Silverflake: You did give it back after...")
        if( self.os[obj] ==4 and self.isShowingDialogBox == False):
            self.os[obj] = 5
            self.createDialogBox(self.portraits[0], "Moonfire: We're going to need it again, though.")
        if( self.os[obj] ==5 and self.isShowingDialogBox == False):
            self.os[obj] = 6
            self.createDialogBox(self.portraits[3], "Silverflake: What? ")
        if( self.os[obj] ==6 and self.isShowingDialogBox == False):
            self.os[obj] = 7
            self.createDialogBox(self.portraits[0], "Melody: Please! There's this very thick fog outside!")
        if( self.os[obj] ==7 and self.isShowingDialogBox == False):
            self.os[obj] = 8
            self.createDialogBox(self.portraits[3], "Silverflake: Fog?")
        if( self.os[obj] ==8 and self.isShowingDialogBox == False):
            self.os[obj] = 9
            self.createDialogBox(self.portraits[0], "Rosewind: Yes, and it has already caused some accidents.")
        if( self.os[obj] ==9 and self.isShowingDialogBox == False):
            self.os[obj] = 10
            self.createDialogBox(self.portraits[3], "Silverflake: Oh, fine... but don't break anything. This is a very complex machine.")
        if( self.os[obj] ==10 and self.isShowingDialogBox == False):
            self.os[obj] = 11
            self.createDialogBox(self.portraits[0], "Rosewind: We'll do our best.")
        if( self.os[obj] ==11 and self.isShowingDialogBox == False):
            self.os[obj] = 1
            self.progression = 313

    if(self.progression >= 313):
        if touching(self, obj) and self.os[obj] == 1:
            if game.mykeys.keyPrimaryIsReleased == True:
                self.createDialogBox(self.portraits[3], "Silverflake: Don't break anything. This is a very complex machine.")
                game.mykeys.keyPrimaryIsReleased = False
                self.os[obj] = 1
                         
    return

def dSilverflake(self, obj):
    self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32, self.oy[obj] - self.camera.y - 32), (0, 0, 96, 80))
    return

def uSilverflakeInsideDoor(self, obj, game):
    if touching(self, obj):
        self.nextmap = maploader.OUTSKIRTS
        self.os[obj] = 0
    return

def uDay4LevelIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[0], "Rosewind: The fog is thicker here! Watch your steps. We don't want to hurt ourselves.")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: I can feel a presence...")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Elementals again! I knew it!")
        self.os[obj] = 0
        self.freeze = False
    return


def uDay4BossIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.p2follow = False
        self.p3follow = False
        self.p1x = 19 * 32
        self.p1y = 21 * 32
        self.p3x = 18 * 32
        self.p3y = 22 * 32
        self.p2x = 20 * 32
        self.p2y = 22 * 32
        self.p1dir = 1
        self.p2dir = 1
        self.p3dir = 1
        self.createDialogBox(self.portraits[0], "Rosewind: This is the FOG SPINNER room. \nLook! That's what has been spewing fog all over the town!")

    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[2], "Moonfire: Let's take care of it!")
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Whew, hitting spirits made of fog is really hard...")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: It'll take a while for the fog to disperse. Do you think we should move on to the next floor?")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: I don't think Silverflake would like that...")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Oh, fine. What else can this thing do, anyway?")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Well, there are nine floors.")
        self.os[obj] = 10
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.nextmap = maploader.TOWERROOF
        self.os[obj] = 0
        self.freeze = False
    return

def uDay5BossIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.p2follow = False
        self.p3follow = False
        self.p1x = 19 * 32
        self.p1y = 21 * 32
        self.p3x = 18 * 32
        self.p3y = 22 * 32
        self.p2x = 20 * 32
        self.p2y = 22 * 32
        self.p1dir = 1
        self.p2dir = 1
        self.p3dir = 1
        self.createDialogBox(self.portraits[2], "Moonfire: This is the WIND RESERVOIRS room. \nMagic that can control the wind must be really powerful!")

    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[0], "Rosewind: We still have to stop it. Let's do this!")
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Whew! I'm so tired, I feel like I'm going to fall over...")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Let me help you. I'll walk you home, Melody.")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: I'll come along to give you a hoof.")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.nextmap = maploader.TOWERROOF
        self.os[obj] = 0
        self.freeze = False
    return

def uDay6BossIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.p2follow = False
        self.p3follow = False
        self.p1x = 19 * 32
        self.p1y = 21 * 32
        self.p3x = 18 * 32
        self.p3y = 22 * 32
        self.p2x = 20 * 32
        self.p2y = 22 * 32
        self.p1dir = 1
        self.p2dir = 1
        self.p3dir = 1
        self.createDialogBox(self.portraits[1], "Melody: At last, the SNOW DISPENSER room. \nI can barely feel the tip of my wings...")

    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[2], "Moonfire: We're almost there! Hang on, fillies!")
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Let's hit it with all we've got!")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: We battled clouds, rain, sunlight, wind, fog and snow now. What else can there be?")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: There's nine floors to this tower... I have no idea.")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: I hope we don't get to find out.")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Just in case, I'll set up a new portal.")
        self.os[obj] = 10
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Rosewind: Good plan! See to it.")
        self.os[obj] = 11
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.nextmap = maploader.TOWERROOF
        self.os[obj] = 0
        self.freeze = False
    return


def uDay7BossIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.p2follow = False
        self.p3follow = False
        self.p1x = 19 * 32
        self.p1y = 21 * 32
        self.p3x = 18 * 32
        self.p3y = 22 * 32
        self.p2x = 20 * 32
        self.p2y = 22 * 32
        self.p1dir = 1
        self.p2dir = 1
        self.p3dir = 1
        self.createDialogBox(self.portraits[0], "Rosewind: We've reached the GROUND STABILIZERS room. \nThere it is! ")

    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[1], "Melody: There's a huge worm tangled up in the machine!")
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Oh ew ew ew ew ewww. I hate worms!")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: I. HATE. Worms.")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Maybe, but it worked! The machine's running smoothly now.")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: What about the magic?")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: I can feel it draining from the room.")
        self.os[obj] = 10
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Oh, that's good, then!")
        self.os[obj] = 11
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Hmm...")
        self.os[obj] = 12
    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.nextmap = maploader.TOWERROOF
        self.os[obj] = 0
        self.freeze = False
    return

def uDay8BossIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.p2follow = False
        self.p3follow = False
        self.p1x = 19 * 32
        self.p1y = 21 * 32
        self.p3x = 18 * 32
        self.p3y = 22 * 32
        self.p2x = 20 * 32
        self.p2y = 22 * 32
        self.p1dir = 1
        self.p2dir = 1
        self.p3dir = 1
        self.createDialogBox(self.portraits[0], "Rosewind: Ah, the MAGMA FLOW GATES room. \nThose fire elementals were tough!")

    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[2], "Moonfire: Yeah, and this one's their leader.")
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: It looks mean...")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Fillies, let me show you how to fight fire... with fire!")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: I'm the fiery one here!")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: The temperature's going down already!")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Maybe... but the magic is going UP!")
        self.os[obj] = 10
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Up? You mean... to the ninth floor?")
        self.os[obj] = 11
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Rosewind: Oh! Would that explain why the problems are happening so soon one after another?")
        self.os[obj] = 12
    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Rosewind: Oh! Would that explain why the problems are happening so soon one after another?")
        self.os[obj] = 13
    if(self.os[obj] == 13 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: As well as why they're getting worse.")
        self.os[obj] = 14
    if(self.os[obj] == 14 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: The handle is still red hot...")
        self.os[obj] = 15
    if(self.os[obj] == 15 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: You're right... then we will come back tomorrow. Come to my place as soon as the sun is up!")
        self.os[obj] = 16
    if(self.os[obj] == 16 and self.isShowingDialogBox == False):
        self.nextmap = maploader.TOWERROOF
        self.os[obj] = 0
        self.freeze = False
    return


def uDay9BossIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.os[obj] = 2
        self.freeze = True
        self.p2follow = False
        self.p3follow = False
        self.p1x = 19 * 32
        self.p1y = 21 * 32
        self.p3x = 18 * 32
        self.p3y = 22 * 32
        self.p2x = 20 * 32
        self.p2y = 22 * 32
        self.p1dir = 1
        self.p2dir = 1
        self.p3dir = 1
        self.createDialogBox(self.portraits[0], "Rosewind: Is this the DAYTIME CLOCK room? \nOh no! Look over there, it's Silverflake!")

    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[1], "Melody: We have to help him!")
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: I don't think that... thing's going to let us.")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Then we have to destroy it! CHARGE!")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Oh, Silverflake! Are you...")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: Uugh... you were... you were right.")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Shh, don't talk. It's over now.")
        self.os[obj] = 10
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: No... it's on the roof...")
        self.os[obj] = 11
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: What is?")
        self.os[obj] = 12
    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: The Chaos elemental.")
        self.os[obj] = 13
    if(self.os[obj] == 13 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: There is a Chaos elemental in this village??")
        self.os[obj] = 14
    if(self.os[obj] == 14 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: Yes... ")
        self.os[obj] = 15
    if(self.os[obj] == 15 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: What's a Chaos elemental?")
        self.os[obj] = 16
    if(self.os[obj] == 16 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: They're created when a vortex of elemental magic is opened up. But they're incredibly rare and powerful!")
        self.os[obj] = 17
    if(self.os[obj] == 17 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: That's... that's why I used the crystals to contain it. But the crystals were flawed... not.. not strong enough.")
        self.os[obj] = 18
    if(self.os[obj] == 18 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: You need some rest. ")
        self.os[obj] = 19
    if(self.os[obj] == 19 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: No! I... I need to save the village. Fix... my own mistake.")
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: We'll take care of it.")
        self.os[obj] = 21
    if(self.os[obj] == 21 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: ...")
        self.os[obj] = 22
    if(self.os[obj] == 22 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: You can barely stand!")
        self.os[obj] = 23
    if(self.os[obj] == 23 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[3], "Silverflake: You're... you're right. Take this key.")
        self.os[obj] = 24
    if(self.os[obj] == 24 and self.isShowingDialogBox == False):
        self.nextmap = maploader.REALROOF
        self.os[obj] = 0
        self.freeze = False
    return

def uDay5LevelIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[0], "Rosewind: Oof! I usually like the wind, but this is too much!")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Oh, look, more elementals.")
        self.os[obj] = 0
        self.freeze = False
    return

def uDay6LevelIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[0], "Rosewind: Brr... it's so cold in here!.")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Time for a thaw-out, then!")
        self.os[obj] = 0
        self.freeze = False
    return


def uDay7LevelIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[0], "Rosewind: Are those... worms?")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: They're just another shape of elementals. ")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Ew.")
        self.os[obj] = 0
        self.freeze = False
    return


def uDay8LevelIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[0], "Rosewind: Woah! ")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: It's really hot in here...")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Watch out! That red stuff... is that lava?")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: How did Silverflake get lava up here?")
        self.os[obj] = 5
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Somehow, I don't think it's supposed to even be there. The magic buildup in this place is incredible!")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Which means more elementals.")
        self.os[obj] = 0
        self.freeze = False
    return

def uDay9LevelIntro(self, obj, game):
    if(self.os[obj] == 1):
        self.createDialogBox(self.portraits[0], "Rosewind: Finally... this is the last floor.")
        self.os[obj] = 2
        self.freeze = True
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: *cough cough* Ugh...")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Are you all right?")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: I'm fine. Us unicorns are really sensitive to magic.")
        self.os[obj] = 5
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Well... don't hurt yourself, okay?")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: I won't. If anyone's about to get hurt, it's them!")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: These are the scariest elementals yet...")
        self.os[obj] = 0
        self.freeze = False
    return

def uDay6WakeUp(self, obj, game):

    if(self.os[obj] == 1):
        self.p1x = 19 * 32
        self.p1y = 20 * 32
        self.p2x = 20 * 32
        self.p2y = 19 * 32
        self.p3x = 21 * 32
        self.p3y = 18 * 32
        self.p1dir = 3
        self.p2dir = 3
        self.p3dir = 3
        self.freeze = True
        self.player.hasMoonfire = True
        self.player.hasMelody = True
        self.p1xb = [(self.p3x * i + self.p1x * (40 - i))/40 for i in range(40)]
        self.p1yb = [(self.p3y * i + self.p1y * (40 - i))/40 for i in range(40)]
        self.createDialogBox(self.portraits[1], "Melody: Thank you for letting us sleep over.")
        self.os[obj] = 2
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: We already knew we'd be going back to the tower today, so I wanted to talk about strategy!")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Yeah. Snow in the middle of the summer? This is just... wrong.")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.createDialogBox(self.portraits[0], "Rosewind: I know I shouldn't, but I kept the key again.")
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.os[obj] = 6
        self.createDialogBox(self.portraits[1], "Melody: Silverflake is going to be so mad...")
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.os[obj] = 7
        self.createDialogBox(self.portraits[0], "Rosewind: It's an emergency, Melody!")
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.os[obj] = 8
        self.createDialogBox(self.portraits[1], "Melody: Still...")
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.os[obj] = 9
        self.createDialogBox(self.portraits[2], "Moonfire: We should go before there's too much snow.")
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.os[obj] = 0
        self.freeze = False
        self.createDialogBox(self.portraits[0], "Rosewind: Good plan.")
    return

def uDay9WakeUp(self, obj, game):

    if(self.os[obj] == 1):
        self.freeze = True
        self.player.hasMoonfire = False
        self.player.hasMelody = False
        self.p1x = 13 * 32 + 16
        self.p1y = 17 * 32 + 16
        self.p1dir = 3
        self.createDialogBox(self.portraits[0], "(Rosewind is asleep. It's dark. Someone knocks at the door)")
        self.os[obj] = 2
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Wha... what?")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Rosewind!")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.os[obj] = 5
        self.p1x = 15 * 32
        self.p1dir = 2
        self.createDialogBox(self.portraits[0], "Rosewind: What are you two doing here? It's still night...")
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.os[obj] = 6
        self.createDialogBox(self.portraits[2], "Moonfire: Exactly! It's night!")
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.os[obj] = 7
        self.createDialogBox(self.portraits[0], "Rosewind: Huh?")
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.os[obj] = 8
        self.createDialogBox(self.portraits[1], "Melody: It's half past eight.")
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.os[obj] = 9
        self.createDialogBox(self.portraits[0], "Rosewind: What? Are you serious??")
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.os[obj] = 10
        self.createDialogBox(self.portraits[2], "Moonfire: I'm afraid so. The sun didn't rise.")
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.os[obj] = 11
        self.createDialogBox(self.portraits[0], "Rosewind: Oh no!")
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.os[obj] = 12
        self.createDialogBox(self.portraits[1], "Melody: Maybe Silverflake was right... we did cause all this!")
    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.os[obj] = 13
        self.createDialogBox(self.portraits[0], "Rosewind: Maybe... but we have to fix it now!")
    if(self.os[obj] == 13 and self.isShowingDialogBox == False):
        self.os[obj] = 14
        self.createDialogBox(self.portraits[1], "Melody: But how can we do it?")
    if(self.os[obj] == 14 and self.isShowingDialogBox == False):
        self.os[obj] = 0
        self.freeze = False
        self.createDialogBox(self.portraits[0], "Rosewind: I... I'm not sure. Let's go ask him.")
    return

def uOrbdead(self, obj, game):
    return


def dOrbdead(self, obj):
    self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (32, 96, 32, 64))
    return

def uOrbBoss(self, obj, game):
    if(self.os[obj] == 9):
        self.freeze = True
        self.ow[obj] += 1
        if(self.ow[obj] == 250):
            self.os[obj] = 10
            self.ow[obj] = 0

    if(self.os[obj] == 10):
        self.ow[obj] += 1
        if(self.ow[obj] == 80):
            self.os[obj] = 11
            self.createDialogBox(self.portraits[2], "Moonfire: The flow of magic energy has converged into an entity of chaos!")
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: This is it, everyone!")
        self.os[obj] = 12
    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: We're making this happen!")
        self.os[obj] = 13
    if(self.os[obj] == 13 and self.isShowingDialogBox == False):
        game.battlescene.initializeBattle(game, self.towerlevel, True)
        game.switchToBattleScene()
        self.os[obj] = 20
    if(self.os[obj] == 20 and self.isShowingDialogBox == False):
            self.freeze = False
            self.nextmap = maploader.ENDBOSS
            self.os[obj] = 14
    return

def dOrbBoss(self, obj):
    if(self.os[obj] == 9):
        self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (0, 96, 32, 64))

    if(self.os[obj] == 9):
        csize = 500 - self.ow[obj]*2
        if(csize >= 1):
            self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (32 * (self.os[obj] - 1), 32, 32, 64))
            pygame.draw.circle(self.screen, (255, 255, 255), (self.ox[obj] - self.camera.x + 16, self.oy[obj] - self.camera.y + 16), csize, 2)

    if(self.os[obj] == 10):
        self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x - 16, self.oy[obj] - self.camera.y), (128, 96, 64, 64))
        csize = self.ow[obj]*3
        csize2 = (csize * (80 - self.ow[obj]))/80
        if(csize2 > csize):
            csize2 = csize
        if(csize >= 1):
            self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (32 * (self.os[obj] - 1), 32, 32, 64))
            pygame.draw.circle(self.screen, (255, 255, 255), (self.ox[obj] - self.camera.x + 16, self.oy[obj] - self.camera.y + 16), csize, int(csize2))

    if(self.os[obj] > 10):
        self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x - 16, self.oy[obj] - self.camera.y), (128, 96, 64, 64))
    return

def uWin(self, obj, game):
    if(self.os[obj] == 1):
        self.p1x = 20 * 32
        self.p1y = 22 * 32
        self.p1dir = 1
        self.p2x = self.p1x - 32 - 8
        self.p2y = self.p1y - 24
        self.p2dir = 1
        self.p3x = self.p1x + 32 + 8
        self.p3y = self.p1y - 24
        self.p3dir = 1
        self.freeze = True
        self.p2follow = False
        self.p3follow = False
        self.createDialogBox(self.portraits[0], "Rosewind: Is it finally over?")
        self.os[obj] = 2
    if(self.os[obj] == 2 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: The magic level went down. I can barely feel any energy around anymore!")
        self.os[obj] = 3
    if(self.os[obj] == 3 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: Then the town is safe?")
        self.os[obj] = 4
    if(self.os[obj] == 4 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Yes, I'd say it's safe now.")
        self.os[obj] = 5
    if(self.os[obj] == 5 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: There's one problem... ")
        self.os[obj] = 6
    if(self.os[obj] == 6 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Oh? What is it?")
        self.os[obj] = 7
    if(self.os[obj] == 7 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[2], "Moonfire: Without the Chaos elemental to power it, the weather tower won't work anymore!")
        self.os[obj] = 8
    if(self.os[obj] == 8 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Then we'll have to live without it.")
        self.os[obj] = 9
    if(self.os[obj] == 9 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[1], "Melody: I'll say... we've gone through enough strange weather lately anyway.")
        self.os[obj] = 10
    if(self.os[obj] == 10 and self.isShowingDialogBox == False):
        self.createDialogBox(self.portraits[0], "Rosewind: Heh... with this shining sun, I think... we should have a picnic!")
        self.os[obj] = 11
    if(self.os[obj] == 11 and self.isShowingDialogBox == False):
        self.os[obj] = 12
        self.createDialogBox(self.portraits[0], "Thanks for playing, and I hope you had as much fun plaything through this as we had making it! \n Graphics: Joel Bouchard Lamontagne, Isabelle Bouchard \n Storyline: Isabelle Bouchard \n Music: Hubert Lamontagne \n Programming: Francis Brousseau-Foley, Joel Bouchard Lamontagne \n See you next time!")
    if(self.os[obj] == 12 and self.isShowingDialogBox == False):
        self.os[obj] = 0
        self.day = 0
        self.nextmap = maploader.ROSEWINDHOUSE
        self.progression = 0
        self.enteredBakery = False
        self.freeze = False
        self.p2follow = False
        self.p3follow = False
        
    return

def uDeadSilver(self, obj, game):
    return

def dDeadSilver(self, obj):
    self.screen.blit(self.silverflakeImage, (self.ox[obj] - self.camera.x - 32, self.oy[obj] - self.camera.y - 32), (13*96, 0, 96, 80))
    return

def uChest(self, obj, game):
    if touching(self, obj) and self.os[obj] < 1000:
        if game.mykeys.keyPrimaryIsReleased == True:
            game.mykeys.keyPrimaryIsReleased = False
            if self.os[obj] == 1:
                self.createDialogBox(self.portraits[0], "Picked up a pointy stick!")
                self.player.items.addToInventory(self.os[obj])
            if self.os[obj] == 2:
                self.createDialogBox(self.portraits[0], "Picked up a dagger!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 3:
                self.createDialogBox(self.portraits[0], "Picked up an iron sword!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 4:
                self.createDialogBox(self.portraits[0], "Picked up a long sword!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 5:
                self.createDialogBox(self.portraits[0], "Picked up a pirate sword!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 6: 
                self.createDialogBox(self.portraits[0], "Picked up a very large sword!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 7:
                self.createDialogBox(self.portraits[0], "Picked up a whistle!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 8:
                self.createDialogBox(self.portraits[0], "Picked up a bell!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 9:
                self.createDialogBox(self.portraits[0], "Picked up a flute!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 10:
                self.createDialogBox(self.portraits[0], "Picked up a harp!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 11:
                self.createDialogBox(self.portraits[0], "Picked up a saxophone!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 14:
                self.createDialogBox(self.portraits[0], "Picked up a novel!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 15:
                self.createDialogBox(self.portraits[0], "Picked up a dangerous book!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 16:
                self.createDialogBox(self.portraits[0], "Picked up a magical book!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 17:
                self.createDialogBox(self.portraits[0], "Picked up a spellbook!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 21:
                self.createDialogBox(self.portraits[0], "Picked up a cape!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 22:
                self.createDialogBox(self.portraits[0], "Picked up a saddle!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 23:
                self.createDialogBox(self.portraits[0], "Picked up a ribbon!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 24:
                self.createDialogBox(self.portraits[0], "Picked up a medal!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 25:
                self.createDialogBox(self.portraits[0], "Picked up a jeweled collar!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 26:
                self.createDialogBox(self.portraits[0], "Picked up a leg band!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 27:
                self.createDialogBox(self.portraits[0], "Picked up a wizard hat!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 28:
                self.createDialogBox(self.portraits[0], "Picked up a muffin!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 29:
                self.createDialogBox(self.portraits[0], "Picked up a cupcake!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 30:
                self.createDialogBox(self.portraits[0], "Picked up an apple pie!")
                self.player.items.addToInventory(self.os[obj])

            if self.os[obj] == 31:
                self.createDialogBox(self.portraits[0], "Picked up an apple!")
                self.player.items.addToInventory(31)

            self.os[obj] = 1000
    return


def dChest(self, obj):
    if self.os[obj] < 1000:
        self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (192, 96, 32, 32))
    else:
        self.screen.blit(self.mapObjectImage, (self.ox[obj] - self.camera.x, self.oy[obj] - self.camera.y), (192 + 32, 96, 32, 32))

    return
