
try:
  import pygame
  from pygame.locals import *
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

# TODO: REDO TO ALLOW KEYS CUSTOMIZATION
class Keys:
  def __init__(self):
    self.initialize()
    
  def initialize(self):
    self.keyLeft = False
    self.keyUp = False
    self.keyRight = False
    self.keyDown = False
    self.keyPrimary = False
    self.keySecondary = False
    self.keyMenu = False
    self.keyEscape = False
    
    self.keyPrimaryIsReleased = False
    self.keySecondaryIsReleased = False
    self.keyMenuIsReleased = False
    self.keyLeftIsReleased = False
    self.keyUpIsReleased = False
    self.keyRightIsReleased = False
    self.keyDownIsReleased = False
    return
    	
  def update(self):
      for event in pygame.event.get():
        if event.type == KEYDOWN:
          if event.key == K_LEFT:
            self.keyLeft = True
          if event.key == K_UP:
            self.keyUp = True
          if event.key == K_RIGHT:
            self.keyRight = True
          if event.key == K_DOWN:
            self.keyDown = True
          if event.key == K_d or event.key == K_RETURN or event.key == K_SPACE or event.key == K_z:
            self.keyPrimary = True
          if event.key == K_s or event.key == K_x or event.key == K_RCTRL or event.key == K_LCTRL:
            self.keySecondary = True
          if event.key == K_a or event.key == K_LSHIFT or event.key == K_RSHIFT or event.key == K_c or event.key == K_TAB:
            self.keyMenu = True
          if event.key == K_ESCAPE:
            self.keyEscape = True
        elif event.type == KEYUP:
          if event.key == K_LEFT:
            if self.keyLeft == True:
              self.keyLeftIsReleased = True
            self.keyLeft = False
          if event.key == K_UP:
            if self.keyUp == True:
              self.keyUpIsReleased = True
            self.keyUp = False
          if event.key == K_RIGHT:
            if self.keyRight == True:
              self.keyRightIsReleased = True
            self.keyRight = False
          if event.key == K_DOWN:
            if self.keyDown == True:
              self.keyDownIsReleased = True
            self.keyDown = False
          if event.key == K_d or event.key == K_RETURN or event.key == K_SPACE or event.key == K_z:
            if self.keyPrimary == True:
              self.keyPrimaryIsReleased = True
            self.keyPrimary = False
          if event.key == K_s or event.key == K_x or event.key == K_RCTRL or event.key == K_LCTRL:
            if self.keySecondary == True:
              self.keySecondaryIsReleased = True
            self.keySecondary = False
          if event.key == K_a or event.key == K_LSHIFT or event.key == K_RSHIFT or event.key == K_c or event.key == K_TAB:
            if self.keyMenu == True:
              self.keyMenuIsReleased = True
            self.keyMenu = False
          #if event.key == K_ESCAPE:
          #	self.keyEscape = False