
try:
  import pygame
  import data
  import graphics
  import random
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

MAP_TILE_WIDTH = 20
MAP_TILE_HEIGHT = 15
WIDTH = MAP_TILE_WIDTH * 32
HEIGHT = MAP_TILE_HEIGHT * 32
  
class Level:
  
  def __init__(self, filename):
    self.numTilesWidth = -1
    self.numTilesHeight = -1
    self.tiles = self.loadLevel(filename)
  
  def saveLevel(self, filename):
    return
  
  def getTile(self, x, y):
    tileX = int(x/32)
    tileY = int(y/32)
    return (tileX + tileY * self.numTilesWidth)
    
  def loadLevel(self, filename):
    file = data.load(filename)
    self.numTilesWidth = int(file.readline())
    self.numTilesHeight = int(file.readline())
    tiles = [0 for i in range(self.numTilesWidth * self.numTilesHeight)]
    row = 0
    while row < self.numTilesHeight:
      col = 0
      rowStr = file.readline()
      tilesRow = rowStr.split(",")
      while col < self.numTilesWidth:
        tiles[row * self.numTilesWidth + col] = int(tilesRow[col])
        col += 1
      row += 1
    return tiles
    
  def update(self):
    return