try:
  #import sys
  import pygame
  import graphics
  import data
except ImportError, err:
  print "couldn't load module. %s" % (err)
  sys.exit(2)

class Scene:
  def __init__(self, game):
    self.screen = game.screen
    self.isFadingOut = True
    self.isFadingIn = False
    self.alpha = 255
  
  def update(self):
    return
    
  def render(self):
    return
  
  def fadeOut(self):
   alphaBackground = pygame.Surface(self.screen.get_size())
   alphaBackground = alphaBackground.convert_alpha()
   alphaBackground.fill((0, 0, 0, self.alpha))
   self.screen.convert_alpha()
   
   if self.alpha > 0:
     alphaBackground.fill((0, 0, 0, self.alpha))
     self.screen.blit(alphaBackground, (0,0))
     self.alpha -= 9
     if (self.alpha <= 0):
       self.alpha = 0
       self.isFadingOut = False
   return
   
  def fadeIn(self):
   alphaBackground = pygame.Surface(self.screen.get_size())
   alphaBackground = alphaBackground.convert_alpha()
   alphaBackground.fill((0, 0, 0, self.alpha))
   self.screen.convert_alpha()
   
   if self.alpha < 255:
     alphaBackground.fill((0, 0, 0, self.alpha))
     self.screen.blit(alphaBackground, (0,0))
     self.alpha += 9
     if (self.alpha >= 255):
       self.alpha = 255
       self.isFadingIn = False
   return 
    